;*****************************************************************************
;				NICST TOOL
;
;  Odd - even average the FP-13 LWIR crosstalk coefficients.
;  
;  v1.0 - 11/20/2007 - Jeff McIntire
;*****************************************************************************

PRO SMWIR_odd_even

close,/all

band_name=['I3','I4','M10','M11','M12','M13','M8','M9']
nband=n_elements(band_name)
ndet_I=32
ndet_M=16

uaidname=['3102097','3102104','3102107','3102118','3102124','3102150','3102163','3102164','3102165','3102168','3102193']
n_uaid=N_ELEMENTS(uaidname)
colnum=[33,36,69,33,39,66,8,28,57,49,33]

fmt='(d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13)'
header='M13_o  M13_e  M12_o  M12_e  I4_SS1_o  I4_SS1_e  I4_SS2_o  I4_SS2_e  I3_SS1_o  I3_SS1_e  I3_SS2_o  I3_SS2_e  M10_o  M10_e  M11_o  M11_e  M8_o  M8_e  M9_o  M9_e'

;*****************************************************************************
;  Read in data and create output files.
;*****************************************************************************

FOR uaid=0, n_uaid-1 DO BEGIN
	IF uaid NE 8 AND uaid NE 9 THEN BEGIN
		outfname1='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.odd_even.dn.dat'
		outfname2='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.odd_even.L.dat'
		outfname3='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.odd_even.CNR.dat'
		outfname4='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.odd_even.PVP.dat'
		openw,lun,outfname1,/get_lun
		openw,lon,outfname2,/get_lun
		openw,len,outfname3,/get_lun
		openw,lin,outfname4,/get_lun
		printf,lun,header
		printf,lon,header
		printf,len,header
		printf,lin,header
	ENDIF
	IF uaid EQ 8 OR uaid EQ 9 THEN BEGIN
		outfname1='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.odd_even.alg.dn.dat'
		outfname2='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.odd_even.flg.dn.dat'
		outfname3='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.odd_even.alg.L.dat'
		outfname4='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.odd_even.flg.L.dat'
		outfname5='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.odd_even.alg.CNR.dat'
		outfname6='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.odd_even.flg.CNR.dat'
		outfname7='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.odd_even.alg.PVP.dat'
		outfname8='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.odd_even.flg.PVP.dat'
		openw,lun,outfname1,/get_lun
		openw,lon,outfname3,/get_lun
		openw,len,outfname5,/get_lun
		openw,lin,outfname7,/get_lun
		openw,lun_2,outfname2,/get_lun
		openw,lon_2,outfname4,/get_lun
		openw,len_2,outfname6,/get_lun
		openw,lin_2,outfname8,/get_lun
		printf,lun,header
		printf,lon,header
		printf,len,header
		printf,lin,header
		printf,lun_2,header
		printf,lon_2,header
		printf,len_2,header
		printf,lin_2,header
	ENDIF

	infname1='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.dn.sav'
;	infname2='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.coeff.sav'
	infname2='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.snd_avg_coeff.sav'
	check=FILE_SEARCH(infname1)
	IF check EQ '' THEN BEGIN
		print,'No file is found.',infname1
		goto,skip_loop
	ENDIF
	print,'Processing file:',infname1
	print,'Processing file:',infname2
	restore,infname1
	restore,infname2

	; reformed data
	XF_dn_I_odd=fltarr(ndet_I,2,2,2)
	XF_dn_I_even=fltarr(ndet_I,2,2,2)
	XF_L_I_odd=fltarr(ndet_I,2,2,2)
	XF_L_I_even=fltarr(ndet_I,2,2,2)
	CNR_I_odd=fltarr(ndet_I,2,2,2)
	CNR_I_even=fltarr(ndet_I,2,2,2)
	PVP_I_odd=fltarr(ndet_I,2,2,2)
	PVP_I_even=fltarr(ndet_I,2,2,2)
	XF_dn_M_odd=fltarr(ndet_I,2,6)
	XF_dn_M_even=fltarr(ndet_I,2,6)
	XF_L_M_odd=fltarr(ndet_I,2,6)
	XF_L_M_even=fltarr(ndet_I,2,6)
	CNR_M_odd=fltarr(ndet_I,2,6)
	CNR_M_even=fltarr(ndet_I,2,6)
	PVP_M_odd=fltarr(ndet_I,2,6)
	PVP_M_even=fltarr(ndet_I,2,6)

	; reformed data for dual gain bands
	XF_dn_I_odd_g=fltarr(ndet_I,2,2,2,2,2)
	XF_dn_I_even_g=fltarr(ndet_I,2,2,2,2,2)
	XF_L_I_odd_g=fltarr(ndet_I,2,2,2,2,2)
	XF_L_I_even_g=fltarr(ndet_I,2,2,2,2,2)
	CNR_I_odd_g=fltarr(ndet_I,2,2,2,2,2)
	CNR_I_even_g=fltarr(ndet_I,2,2,2,2,2)
	PVP_I_odd_g=fltarr(ndet_I,2,2,2,2,2)
	PVP_I_even_g=fltarr(ndet_I,2,2,2,2,2)
	XF_dn_M_odd_g=fltarr(ndet_I,2,6,2,2)
	XF_dn_M_even_g=fltarr(ndet_I,2,6,2,2)
	XF_L_M_odd_g=fltarr(ndet_I,2,6,2,2)
	XF_L_M_even_g=fltarr(ndet_I,2,6,2,2)
	CNR_M_odd_g=fltarr(ndet_I,2,6,2,2)
	CNR_M_even_g=fltarr(ndet_I,2,6,2,2)
	PVP_M_odd_g=fltarr(ndet_I,2,6,2,2)
	PVP_M_even_g=fltarr(ndet_I,2,6,2,2)

;*****************************************************************************
;  Skip bad collects and reform data.
;*****************************************************************************

	count1=0
	count2=0
	FOR col=0, colnum[uaid]-1 DO BEGIN
		flag=0

		; U3102097
		IF uaid EQ 0 THEN BEGIN
			IF col EQ 16 THEN goto,skip_col
		ENDIF

		; U3102104
		IF uaid EQ 1 THEN BEGIN
			IF col EQ 18 OR col EQ 19 OR col EQ 22 OR col EQ 23 THEN goto,skip_col
		ENDIF

		; U3102107
		IF uaid EQ 2 THEN BEGIN
			IF col EQ 4 OR col EQ 23 OR col EQ 24 OR col EQ 41 OR col EQ 64 THEN goto,skip_col
		ENDIF

		; U3102118
		IF uaid EQ 3 THEN BEGIN
			IF col EQ 4 THEN goto,skip_col
		ENDIF

		; U3102124
		IF uaid EQ 4 THEN BEGIN
			IF col EQ 0 OR col EQ 1 OR col EQ 2 OR col EQ 4 OR col EQ 6 OR col EQ 7 $
				OR col EQ 8 OR col EQ 10 OR col EQ 12 OR col EQ 14 OR col EQ 15 $
				OR col EQ 17 OR col EQ 19 OR col EQ 21 OR col EQ 23 OR col EQ 25 $
				OR col EQ 26 OR col EQ 28 OR col EQ 30 OR col EQ 32 OR col EQ 34 $
				OR col EQ 36 OR col EQ 38 THEN goto,skip_col
		ENDIF

		; U3102150
		IF uaid EQ 5 THEN BEGIN
			IF col EQ 0 OR col EQ 53 THEN goto,skip_col
		ENDIF

		; U3102163
		IF uaid EQ 6 THEN BEGIN
			IF col EQ 0 OR col EQ 1 OR col EQ 3 OR col EQ 4 OR col EQ 5 OR col EQ 7 $
				THEN goto,skip_col
		ENDIF

		; U3102164
		IF uaid EQ 7 THEN BEGIN
			IF col EQ 1 OR col EQ 3 OR col EQ 5 OR col EQ 7 OR col EQ 9 OR col EQ 11 $
				OR col EQ 13 OR col EQ 15 OR col EQ 17 OR col EQ 19 OR col EQ 21 $
				OR col EQ 23 OR col EQ 25 OR col EQ 27 THEN goto,skip_col
		ENDIF

		; U3102165
		IF uaid EQ 8 THEN BEGIN
			IF col EQ 1 OR col EQ 4 OR col EQ 7 OR col EQ 10 OR col EQ 13 OR col EQ 15 $
				OR col EQ 17 OR col EQ 20 OR col EQ 23 OR col EQ 25 OR col EQ 26 $
				OR col EQ 27 OR col EQ 29 OR col EQ 32 OR col EQ 35 OR col EQ 38 $
				OR col EQ 41 OR col EQ 44 OR col EQ 46 OR col EQ 47 OR col EQ 48 $
				OR col EQ 49 OR col EQ 50 OR col EQ 52 OR col EQ 55 THEN goto,skip_col
		ENDIF
		; U3102165 auto low collects
		IF uaid EQ 8 THEN BEGIN
			IF col EQ 0 OR col EQ 3 OR col EQ 6 OR col EQ 9 OR col EQ 12 OR col EQ 16 $
				OR col EQ 19 OR col EQ 22 OR col EQ 28 OR col EQ 31 OR col EQ 34 $
				OR col EQ 37 OR col EQ 40 OR col EQ 43 OR col EQ 51 OR col EQ 54 THEN flag=2
		ENDIF
		; U3102165 fixed low collects
		IF uaid EQ 8 THEN BEGIN
			IF col EQ 2 OR col EQ 5 OR col EQ 8 OR col EQ 11 OR col EQ 14 OR col EQ 18 $
				OR col EQ 21 OR col EQ 24 OR col EQ 30 OR col EQ 33 OR col EQ 36 $
				OR col EQ 39 OR col EQ 42 OR col EQ 45 OR col EQ 53 OR col EQ 56 THEN flag=1
		ENDIF

		; U3102168
		IF uaid EQ 9 THEN BEGIN
			IF col EQ 0 OR col EQ 1 OR col EQ 5 OR col EQ 8 OR col EQ 11 OR col EQ 14 $
				OR col EQ 17 OR col EQ 20 OR col EQ 23 OR col EQ 26 OR col EQ 29 $
				OR col EQ 32 OR col EQ 35 OR col EQ 38 OR col EQ 41 OR col EQ 44 $
				OR col EQ 47 THEN goto,skip_col
		ENDIF
		; U3102168 auto low collects
		IF uaid EQ 9 THEN BEGIN
			IF col EQ 3 OR col EQ 4 OR col EQ 7 OR col EQ 10 OR col EQ 13 OR col EQ 16 $
				OR col EQ 19 OR col EQ 22 OR col EQ 25 OR col EQ 28 OR col EQ 31 $
				OR col EQ 34 OR col EQ 37 OR col EQ 40 OR col EQ 43 OR col EQ 46 THEN flag=2
		ENDIF
		; U3102168 fixed low collects
		IF uaid EQ 9 THEN BEGIN
			IF col EQ 2 OR col EQ 6 OR col EQ 9 OR col EQ 12 OR col EQ 15 OR col EQ 18 $
				OR col EQ 21 OR col EQ 24 OR col EQ 27 OR col EQ 30 OR col EQ 33 $
				OR col EQ 36 OR col EQ 39 OR col EQ 42 OR col EQ 45 OR col EQ 48 THEN flag=1
		ENDIF

		; U3102193
		IF uaid EQ 10 THEN BEGIN
			IF col EQ 0 THEN goto,skip_col
		ENDIF

		band_lit=fix(high_det[col,0])
		det_lit=fix(high_det[col,1])

		XF_dn_I=fltarr(ndet_I,2,2,ndet_I,2)
		XF_L_I=fltarr(ndet_I,2,2,ndet_I,2)
		CNR_I=fltarr(ndet_I,2,2,ndet_I,2)
		PVP_I=fltarr(ndet_I,2,2,ndet_I,2)
		FOR j=0, 1 DO BEGIN
			FOR i=0, ndet_I-1, 2 DO BEGIN
				XF_dn_I[*,*,j,i,0]=XF_dn[col,*,*,j,i,0]
				XF_dn_I[*,*,j,i+1,0]=XF_dn[col,*,*,j,i+1,1]
				XF_dn_I[*,*,j,i,1]=XF_dn[col,*,*,j,i,1]
				XF_dn_I[*,*,j,i+1,1]=XF_dn[col,*,*,j,i+1,0]

				XF_L_I[*,*,j,i,0]=XF_L[col,*,*,j,i,0]
				XF_L_I[*,*,j,i+1,0]=XF_L[col,*,*,j,i+1,1]
				XF_L_I[*,*,j,i,1]=XF_L[col,*,*,j,i,1]
				XF_L_I[*,*,j,i+1,1]=XF_L[col,*,*,j,i+1,0]

				CNR_I[*,*,j,i,0]=CNR[col,*,*,j,i,0]
				CNR_I[*,*,j,i+1,0]=CNR[col,*,*,j,i+1,1]
				CNR_I[*,*,j,i,1]=CNR[col,*,*,j,i,1]
				CNR_I[*,*,j,i+1,1]=CNR[col,*,*,j,i+1,0]

				PVP_I[*,*,j,i,0]=PVP[col,*,*,j,i,0]
				PVP_I[*,*,j,i+1,0]=PVP[col,*,*,j,i+1,1]
				PVP_I[*,*,j,i,1]=PVP[col,*,*,j,i,1]
				PVP_I[*,*,j,i+1,1]=PVP[col,*,*,j,i+1,0]
			ENDFOR
		ENDFOR

		XF_dn_M=(reform(XF_dn[col,*,*,2:7,0:15,0]))
		XF_L_M=(reform(XF_L[col,*,*,2:7,0:15,0]))
		CNR_M=(reform(CNR[col,*,*,2:7,0:15,0]))
		PVP_M=(reform(PVP[col,*,*,2:7,0:15,0]))

		IF band_lit LE 1 THEN n_det=32
		IF band_lit LE 1 THEN n_s=2
		IF band_lit GE 2 THEN n_det=16
		IF band_lit GE 2 THEN n_s=1

;*****************************************************************************
;  Make subsample 1 for the I bands higher.
;*****************************************************************************

		XF_dn_I_t=fltarr(ndet_I,2,2,ndet_I,2)
		XF_L_I_t=fltarr(ndet_I,2,2,ndet_I,2)
		CNR_I_t=fltarr(ndet_I,2,2,ndet_I,2)
		PVP_I_t=fltarr(ndet_I,2,2,ndet_I,2)
		FOR s_s=0, n_s-1 DO BEGIN
			FOR r_s=0, 1 DO BEGIN
				FOR ib=0, 1 DO BEGIN
					IF mean(XF_L_I[det_lit,s_s,ib,*,0]) GT $
						mean(XF_L_I[det_lit,s_s,ib,*,1]) THEN BEGIN
						FOR id=0, ndet_I-1 DO BEGIN

							XF_dn_I_t[det_lit,s_s,ib,id,0]=XF_dn_I[det_lit,s_s,ib,id,0]
							XF_dn_I_t[det_lit,s_s,ib,id,1]=XF_dn_I[det_lit,s_s,ib,id,1]
							XF_L_I_t[det_lit,s_s,ib,id,0]=XF_L_I[det_lit,s_s,ib,id,0]
							XF_L_I_t[det_lit,s_s,ib,id,1]=XF_L_I[det_lit,s_s,ib,id,1]
							CNR_I_t[det_lit,s_s,ib,id,0]=CNR_I[det_lit,s_s,ib,id,0]
							CNR_I_t[det_lit,s_s,ib,id,1]=CNR_I[det_lit,s_s,ib,id,1]
							PVP_I_t[det_lit,s_s,ib,id,0]=PVP_I[det_lit,s_s,ib,id,0]
							PVP_I_t[det_lit,s_s,ib,id,1]=PVP_I[det_lit,s_s,ib,id,1]
						ENDFOR
					ENDIF
					IF mean(XF_L_I[det_lit,s_s,ib,*,1]) GT $
						mean(XF_L_I[det_lit,s_s,ib,*,0]) THEN BEGIN
						FOR id=0, ndet_I-1 DO BEGIN

							XF_dn_I_t[det_lit,s_s,ib,id,0]=XF_dn_I[det_lit,s_s,ib,id,1]
							XF_dn_I_t[det_lit,s_s,ib,id,1]=XF_dn_I[det_lit,s_s,ib,id,0]
							XF_L_I_t[det_lit,s_s,ib,id,0]=XF_L_I[det_lit,s_s,ib,id,1]
							XF_L_I_t[det_lit,s_s,ib,id,1]=XF_L_I[det_lit,s_s,ib,id,0]
							CNR_I_t[det_lit,s_s,ib,id,0]=CNR_I[det_lit,s_s,ib,id,1]
							CNR_I_t[det_lit,s_s,ib,id,1]=CNR_I[det_lit,s_s,ib,id,0]
							PVP_I_t[det_lit,s_s,ib,id,0]=PVP_I[det_lit,s_s,ib,id,1]
							PVP_I_t[det_lit,s_s,ib,id,1]=PVP_I[det_lit,s_s,ib,id,0]
						ENDFOR
					ENDIF
				ENDFOR
			ENDFOR
		ENDFOR
		XF_dn_I[det_lit,*,*,*,*]=XF_dn_I_t[det_lit,*,*,*,*]
		XF_L_I[det_lit,*,*,*,*]=XF_L_I_t[det_lit,*,*,*,*]
		CNR_I[det_lit,*,*,*,*]=CNR_I_t[det_lit,*,*,*,*]
		PVP_I[det_lit,*,*,*,*]=PVP_I_t[det_lit,*,*,*,*]

;*****************************************************************************
;  Odd - even average.
;*****************************************************************************

		IF uaid EQ 8 OR uaid EQ 9 THEN goto,uaid_skip
		FOR s_s=0, n_s-1 DO BEGIN
			FOR r_s=0, 1 DO BEGIN
				FOR ib=0, 1 DO BEGIN
					count=0
					count2=0
					FOR id=0, ndet_I-1 DO BEGIN
						IF count EQ 0 THEN BEGIN
							XF_dn_I_odd[det_lit,s_s,ib,r_s]=XF_dn_I_odd[det_lit,s_s,ib,r_s]+ $
								XF_dn_I[det_lit,s_s,ib,id,r_s]
							XF_L_I_odd[det_lit,s_s,ib,r_s]=XF_L_I_odd[det_lit,s_s,ib,r_s]+ $
								XF_L_I[det_lit,s_s,ib,id,r_s]
							CNR_I_odd[det_lit,s_s,ib,r_s]=CNR_I_odd[det_lit,s_s,ib,r_s]+ $
								CNR_I[det_lit,s_s,ib,id,r_s]
							PVP_I_odd[det_lit,s_s,ib,r_s]=PVP_I_odd[det_lit,s_s,ib,r_s]+ $
								PVP_I[det_lit,s_s,ib,id,r_s]
							count=1
							count2=count2+1
							goto,skip_over_1
						ENDIF
						IF count EQ 1 THEN BEGIN
							XF_dn_I_even[det_lit,s_s,ib,r_s]=XF_dn_I_even[det_lit,s_s,ib,r_s]+ $
								XF_dn_I[det_lit,s_s,ib,id,r_s]
							XF_L_I_even[det_lit,s_s,ib,r_s]=XF_L_I_even[det_lit,s_s,ib,r_s]+ $
								XF_L_I[det_lit,s_s,ib,id,r_s]
							CNR_I_even[det_lit,s_s,ib,r_s]=CNR_I_even[det_lit,s_s,ib,r_s]+ $
								CNR_I[det_lit,s_s,ib,id,r_s]
							PVP_I_even[det_lit,s_s,ib,r_s]=PVP_I_even[det_lit,s_s,ib,r_s]+ $
								PVP_I[det_lit,s_s,ib,id,r_s]
							count=0
						ENDIF
						skip_over_1:
					ENDFOR
				ENDFOR
			ENDFOR
		ENDFOR
		XF_dn_I_odd[det_lit,*,*,*]=XF_dn_I_odd[det_lit,*,*,*]/count2
		XF_dn_I_even[det_lit,*,*,*]=XF_dn_I_even[det_lit,*,*,*]/count2
		XF_L_I_odd[det_lit,*,*,*]=XF_L_I_odd[det_lit,*,*,*]/count2
		XF_L_I_even[det_lit,*,*,*]=XF_L_I_even[det_lit,*,*,*]/count2
		CNR_I_odd[det_lit,*,*,*]=CNR_I_odd[det_lit,*,*,*]/count2
		CNR_I_even[det_lit,*,*,*]=CNR_I_even[det_lit,*,*,*]/count2
		PVP_I_odd[det_lit,*,*,*]=PVP_I_odd[det_lit,*,*,*]/count2
		PVP_I_even[det_lit,*,*,*]=PVP_I_even[det_lit,*,*,*]/count2

		FOR ib=0, 5 DO BEGIN
			FOR s_s=0, n_s-1 DO BEGIN
				count=0
				count2=0
				FOR id=0, ndet_M-1 DO BEGIN
					IF count EQ 0 THEN BEGIN
						XF_dn_M_odd[det_lit,s_s,ib]=XF_dn_M_odd[det_lit,s_s,ib]+ $
							XF_dn_M[det_lit,s_s,ib,id]
						XF_L_M_odd[det_lit,s_s,ib]=XF_L_M_odd[det_lit,s_s,ib]+ $
							XF_L_M[det_lit,s_s,ib,id]
						CNR_M_odd[det_lit,s_s,ib]=CNR_M_odd[det_lit,s_s,ib]+ $
							CNR_M[det_lit,s_s,ib,id]
						PVP_M_odd[det_lit,s_s,ib]=PVP_M_odd[det_lit,s_s,ib]+ $
							PVP_M[det_lit,s_s,ib,id]
						count=1
						count2=count2+1
						goto,skip_over_2
					ENDIF
					IF count EQ 1 THEN BEGIN
						XF_dn_M_even[det_lit,s_s,ib]=XF_dn_M_even[det_lit,s_s,ib]+ $
							XF_dn_M[det_lit,s_s,ib,id]
						XF_L_M_even[det_lit,s_s,ib]=XF_L_M_even[det_lit,s_s,ib]+ $
							XF_L_M[det_lit,s_s,ib,id]
						CNR_M_even[det_lit,s_s,ib]=CNR_M_even[det_lit,s_s,ib]+ $
							CNR_M[det_lit,s_s,ib,id]
						PVP_M_even[det_lit,s_s,ib]=PVP_M_even[det_lit,s_s,ib]+ $
							PVP_M[det_lit,s_s,ib,id]
						count=0
					ENDIF
					skip_over_2:
				ENDFOR
			ENDFOR
		ENDFOR
		XF_dn_M_odd[det_lit,*,*]=XF_dn_M_odd[det_lit,*,*]/count2
		XF_dn_M_even[det_lit,*,*]=XF_dn_M_even[det_lit,*,*]/count2
		XF_L_M_odd[det_lit,*,*]=XF_L_M_odd[det_lit,*,*]/count2
		XF_L_M_even[det_lit,*,*]=XF_L_M_even[det_lit,*,*]/count2
		CNR_M_odd[det_lit,*,*]=CNR_M_odd[det_lit,*,*]/count2
		CNR_M_even[det_lit,*,*]=CNR_M_even[det_lit,*,*]/count2
		PVP_M_odd[det_lit,*,*]=PVP_M_odd[det_lit,*,*]/count2
		PVP_M_even[det_lit,*,*]=PVP_M_even[det_lit,*,*]/count2

		uaid_skip:

		IF uaid EQ 8 OR uaid EQ 9 THEN BEGIN
			FOR ib=0, 1 DO BEGIN
				FOR s_s=0, n_s-1 DO BEGIN
					FOR r_s=0, 1 DO BEGIN
						count=0
						count2=0
						FOR id=0, ndet_I-1 DO BEGIN
							IF count EQ 0 THEN BEGIN
								XF_dn_I_odd_g[det_lit,s_s,ib,r_s,1,flag-1]= $
									XF_dn_I_odd_g[det_lit,s_s,ib,r_s,1,flag-1] $
									+XF_dn_I[det_lit,s_s,ib,id,r_s]
								XF_L_I_odd_g[det_lit,s_s,ib,r_s,1,flag-1]= $
									XF_L_I_odd_g[det_lit,s_s,ib,r_s,1,flag-1] $
									+XF_L_I[det_lit,s_s,ib,id,r_s]
								CNR_I_odd_g[det_lit,s_s,ib,r_s,1,flag-1]= $
									CNR_I_odd_g[det_lit,s_s,ib,r_s,1,flag-1] $
									+CNR_I[det_lit,s_s,ib,id,r_s]
								PVP_I_odd_g[det_lit,s_s,ib,r_s,1,flag-1]= $
									PVP_I_odd_g[det_lit,s_s,ib,r_s,1,flag-1] $
									+PVP_I[det_lit,s_s,ib,id,r_s]
								count=1
								count2=count2+1
								goto,skip_over_3
							ENDIF
							IF count EQ 1 THEN BEGIN
								XF_dn_I_even_g[det_lit,s_s,ib,r_s,1,flag-1]= $
									XF_dn_I_even_g[det_lit,s_s,ib,r_s,1,flag-1] $
									+XF_dn_I[det_lit,s_s,ib,id,r_s]
								XF_L_I_even_g[det_lit,s_s,ib,r_s,1,flag-1]= $
									XF_L_I_even_g[det_lit,s_s,ib,r_s,1,flag-1] $
									+XF_L_I[det_lit,s_s,ib,id,r_s]
								CNR_I_even_g[det_lit,s_s,ib,r_s,1,flag-1]= $
									CNR_I_even_g[det_lit,s_s,ib,r_s,1,flag-1] $
									+CNR_I[det_lit,s_s,ib,id,r_s]
								PVP_I_even_g[det_lit,s_s,ib,r_s,1,flag-1]= $
									PVP_I_even_g[det_lit,s_s,ib,r_s,1,flag-1] $
									+PVP_I[det_lit,s_s,ib,id,r_s]
								count=0
							ENDIF
							skip_over_3:
						ENDFOR
						XF_dn_I_odd_g[det_lit,s_s,ib,r_s,1,flag-1]= $
							XF_dn_I_odd_g[det_lit,s_s,ib,r_s,1,flag-1]/count2
						XF_L_I_odd_g[det_lit,s_s,ib,r_s,1,flag-1]= $
							XF_L_I_odd_g[det_lit,s_s,ib,r_s,1,flag-1]/count2
						CNR_I_odd_g[det_lit,s_s,ib,r_s,1,flag-1]= $
							CNR_I_odd_g[det_lit,s_s,ib,r_s,1,flag-1]/count2
						PVP_I_odd_g[det_lit,s_s,ib,r_s,1,flag-1]= $
							PVP_I_odd_g[det_lit,s_s,ib,r_s,1,flag-1]/count2
						XF_dn_I_even_g[det_lit,s_s,ib,r_s,1,flag-1]= $
							XF_dn_I_even_g[det_lit,s_s,ib,r_s,1,flag-1]/count2
						XF_L_I_even_g[det_lit,s_s,ib,r_s,1,flag-1]= $
							XF_L_I_even_g[det_lit,s_s,ib,r_s,1,flag-1]/count2
						CNR_I_even_g[det_lit,s_s,ib,r_s,1,flag-1]= $
							CNR_I_even_g[det_lit,s_s,ib,r_s,1,flag-1]/count2
						PVP_I_even_g[det_lit,s_s,ib,r_s,1,flag-1]= $
							PVP_I_even_g[det_lit,s_s,ib,r_s,1,flag-1]/count2
						XF_dn_I_odd_g[det_lit,s_s,ib,r_s,0,flag-1]=-999
						XF_L_I_odd_g[det_lit,s_s,ib,r_s,0,flag-1]=-999
						CNR_I_odd_g[det_lit,s_s,ib,r_s,0,flag-1]=-999
						PVP_I_odd_g[det_lit,s_s,ib,r_s,0,flag-1]=-999
						XF_dn_I_even_g[det_lit,s_s,ib,r_s,0,flag-1]=-999
						XF_L_I_even_g[det_lit,s_s,ib,r_s,0,flag-1]=-999
						CNR_I_even_g[det_lit,s_s,ib,r_s,0,flag-1]=-999
						PVP_I_even_g[det_lit,s_s,ib,r_s,0,flag-1]=-999
					ENDFOR
				ENDFOR
			ENDFOR

			FOR ib=0, 5 DO BEGIN
				FOR s_s=0, n_s-1 DO BEGIN
					IF ib NE 3 THEN BEGIN
						count=0
						count2=0
						FOR id=0, ndet_M-1 DO BEGIN
							IF count EQ 0 THEN BEGIN
								XF_dn_M_odd_g[det_lit,s_s,ib,1,flag-1]= $
									XF_dn_M_odd_g[det_lit,s_s,ib,1,flag-1] $
									+XF_dn_M[det_lit,s_s,ib,id]
								XF_L_M_odd_g[det_lit,s_s,ib,1,flag-1]= $
									XF_L_M_odd_g[det_lit,s_s,ib,1,flag-1] $
									+XF_L_M[det_lit,s_s,ib,id]
								CNR_M_odd_g[det_lit,s_s,ib,1,flag-1]= $
									CNR_M_odd_g[det_lit,s_s,ib,1,flag-1] $
									+CNR_M[det_lit,s_s,ib,id]
								PVP_M_odd_g[det_lit,s_s,ib,1,flag-1]= $
									PVP_M_odd_g[det_lit,s_s,ib,1,flag-1] $
									+PVP_M[det_lit,s_s,ib,id]
								count=1
								count2=count2+1
								goto,skip_over_4
							ENDIF
							IF count EQ 1 THEN BEGIN
								XF_dn_M_even_g[det_lit,s_s,ib,1,flag-1]= $
									XF_dn_M_even_g[det_lit,s_s,ib,1,flag-1] $
									+XF_dn_M[det_lit,s_s,ib,id]
								XF_L_M_even_g[det_lit,s_s,ib,1,flag-1]= $
									XF_L_M_even_g[det_lit,s_s,ib,1,flag-1] $
									+XF_L_M[det_lit,s_s,ib,id]
								CNR_M_even_g[det_lit,s_s,ib,1,flag-1]= $
									CNR_M_even_g[det_lit,s_s,ib,1,flag-1] $
									+CNR_M[det_lit,s_s,ib,id]
								PVP_M_even_g[det_lit,s_s,ib,1,flag-1]= $
									PVP_M_even_g[det_lit,s_s,ib,1,flag-1] $
									+PVP_M[det_lit,s_s,ib,id]
								count=0
							ENDIF
							skip_over_4:
						ENDFOR
						XF_dn_M_odd_g[det_lit,s_s,ib,1,flag-1]= $
							XF_dn_M_odd_g[det_lit,s_s,ib,1,flag-1]/count2
						XF_L_M_odd_g[det_lit,s_s,ib,1,flag-1]= $
							XF_L_M_odd_g[det_lit,s_s,ib,1,flag-1]/count2
						CNR_M_odd_g[det_lit,s_s,ib,1,flag-1]= $
							CNR_M_odd_g[det_lit,s_s,ib,1,flag-1]/count2
						PVP_M_odd_g[det_lit,s_s,ib,1,flag-1]= $
							PVP_M_odd_g[det_lit,s_s,ib,1,flag-1]/count2
						XF_dn_M_even_g[det_lit,s_s,ib,1,flag-1]= $
							XF_dn_M_even_g[det_lit,s_s,ib,1,flag-1]/count2
						XF_L_M_even_g[det_lit,s_s,ib,1,flag-1]= $
							XF_L_M_even_g[det_lit,s_s,ib,1,flag-1]/count2
						CNR_M_even_g[det_lit,s_s,ib,1,flag-1]= $
							CNR_M_even_g[det_lit,s_s,ib,1,flag-1]/count2
						PVP_M_even_g[det_lit,s_s,ib,1,flag-1]= $
							PVP_M_even_g[det_lit,s_s,ib,1,flag-1]/count2
						XF_dn_M_odd_g[det_lit,s_s,ib,0,flag-1]=-999
						XF_L_M_odd_g[det_lit,s_s,ib,0,flag-1]=-999
						CNR_M_odd_g[det_lit,s_s,ib,0,flag-1]=-999
						PVP_M_odd_g[det_lit,s_s,ib,0,flag-1]=-999
						XF_dn_M_even_g[det_lit,s_s,ib,0,flag-1]=-999
						XF_L_M_even_g[det_lit,s_s,ib,0,flag-1]=-999
						CNR_M_even_g[det_lit,s_s,ib,0,flag-1]=-999
						PVP_M_even_g[det_lit,s_s,ib,0,flag-1]=-999
					ENDIF ELSE BEGIN
						IF flag EQ 2 THEN BEGIN
							count=0
							count2=0
							count3=0
							count4=0
							FOR id=0, ndet_M-1 DO BEGIN
								IF det_low_gain[col,5,id] EQ 1 THEN BEGIN
									IF float(id)/2-fix(id/2) EQ 0 THEN BEGIN
										XF_dn_M_odd_g[det_lit,s_s,ib,0,flag-1]= $
											XF_dn_M_odd_g[det_lit,s_s,ib,0,flag-1] $
											+XF_dn_M[det_lit,s_s,ib,id]
										XF_L_M_odd_g[det_lit,s_s,ib,0,flag-1]= $
											XF_L_M_odd_g[det_lit,s_s,ib,0,flag-1] $
											+XF_L_M[det_lit,s_s,ib,id]
										CNR_M_odd_g[det_lit,s_s,ib,0,flag-1]= $
											CNR_M_odd_g[det_lit,s_s,ib,0,flag-1] $
											+CNR_M[det_lit,s_s,ib,id]
										PVP_M_odd_g[det_lit,s_s,ib,0,flag-1]= $
											PVP_M_odd_g[det_lit,s_s,ib,0,flag-1] $
											+PVP_M[det_lit,s_s,ib,id]
										count3=count3+1
									ENDIF ELSE BEGIN
										XF_dn_M_even_g[det_lit,s_s,ib,0,flag-1]= $
											XF_dn_M_even_g[det_lit,s_s,ib,0,flag-1] $
											+XF_dn_M[det_lit,s_s,ib,id]
										XF_L_M_even_g[det_lit,s_s,ib,0,flag-1]= $
											XF_L_M_even_g[det_lit,s_s,ib,0,flag-1] $
											+XF_L_M[det_lit,s_s,ib,id]
										CNR_M_even_g[det_lit,s_s,ib,0,flag-1]= $
											CNR_M_even_g[det_lit,s_s,ib,0,flag-1] $
											+CNR_M[det_lit,s_s,ib,id]
										PVP_M_even_g[det_lit,s_s,ib,0,flag-1]= $
											PVP_M_even_g[det_lit,s_s,ib,0,flag-1] $
											+PVP_M[det_lit,s_s,ib,id]
										count4=count4+1
									ENDELSE
								ENDIF ELSE BEGIN
									XF_dn_M_odd_g[det_lit,s_s,ib,1,flag-1]= $
										XF_dn_M_odd_g[det_lit,s_s,ib,1,flag-1] $
										+XF_dn_M[det_lit,s_s,ib,id]
									XF_L_M_odd_g[det_lit,s_s,ib,1,flag-1]= $
										XF_L_M_odd_g[det_lit,s_s,ib,1,flag-1] $
										+XF_L_M[det_lit,s_s,ib,id]
									CNR_M_odd_g[det_lit,s_s,ib,1,flag-1]= $
										CNR_M_odd_g[det_lit,s_s,ib,1,flag-1] $
										+CNR_M[det_lit,s_s,ib,id]
									PVP_M_odd_g[det_lit,s_s,ib,1,flag-1]= $
										PVP_M_odd_g[det_lit,s_s,ib,1,flag-1] $
										+PVP_M[det_lit,s_s,ib,id]
									XF_dn_M_even_g[det_lit,s_s,ib,1,flag-1]= $
										XF_dn_M_even_g[det_lit,s_s,ib,1,flag-1] $
										+XF_dn_M[det_lit,s_s,ib,id]
									XF_L_M_even_g[det_lit,s_s,ib,1,flag-1]= $
										XF_L_M_even_g[det_lit,s_s,ib,1,flag-1] $
										+XF_L_M[det_lit,s_s,ib,id]
									CNR_M_even_g[det_lit,s_s,ib,1,flag-1]= $
										CNR_M_even_g[det_lit,s_s,ib,1,flag-1] $
										+CNR_M[det_lit,s_s,ib,id]
									PVP_M_even_g[det_lit,s_s,ib,1,flag-1]= $
										PVP_M_even_g[det_lit,s_s,ib,1,flag-1] $
										+PVP_M[det_lit,s_s,ib,id]
									count2=count2+1
								ENDELSE
							ENDFOR
							IF count3 NE 0 THEN BEGIN
								XF_dn_M_odd_g[det_lit,s_s,ib,0,flag-1]= $
									XF_dn_M_odd_g[det_lit,s_s,ib,0,flag-1]/count3
								XF_L_M_odd_g[det_lit,s_s,ib,0,flag-1]= $
									XF_L_M_odd_g[det_lit,s_s,ib,0,flag-1]/count3
								CNR_M_odd_g[det_lit,s_s,ib,0,flag-1]= $
									CNR_M_odd_g[det_lit,s_s,ib,0,flag-1]/count3
								PVP_M_odd_g[det_lit,s_s,ib,0,flag-1]= $
									PVP_M_odd_g[det_lit,s_s,ib,0,flag-1]/count3
							ENDIF ELSE BEGIN
								XF_dn_M_odd_g[det_lit,s_s,ib,0,flag-1]=-999
								XF_L_M_odd_g[det_lit,s_s,ib,0,flag-1]=-999
								CNR_M_odd_g[det_lit,s_s,ib,0,flag-1]=-999
								PVP_M_odd_g[det_lit,s_s,ib,0,flag-1]=-999
							ENDELSE
							IF count4 NE 0 THEN BEGIN
								XF_dn_M_even_g[det_lit,s_s,ib,0,flag-1]= $
									XF_dn_M_even_g[det_lit,s_s,ib,0,flag-1]/count4
								XF_L_M_even_g[det_lit,s_s,ib,0,flag-1]= $
									XF_L_M_even_g[det_lit,s_s,ib,0,flag-1]/count4
								CNR_M_even_g[det_lit,s_s,ib,0,flag-1]= $
									CNR_M_even_g[det_lit,s_s,ib,0,flag-1]/count4
								PVP_M_even_g[det_lit,s_s,ib,0,flag-1]= $
									PVP_M_even_g[det_lit,s_s,ib,0,flag-1]/count4
							ENDIF ELSE BEGIN
								XF_dn_M_even_g[det_lit,s_s,ib,0,flag-1]=-999
								XF_L_M_even_g[det_lit,s_s,ib,0,flag-1]=-999
								CNR_M_even_g[det_lit,s_s,ib,0,flag-1]=-999
								PVP_M_even_g[det_lit,s_s,ib,0,flag-1]=-999
							ENDELSE
							XF_dn_M_odd_g[det_lit,s_s,ib,1,flag-1]= $
								XF_dn_M_odd_g[det_lit,s_s,ib,1,flag-1]/count2
							XF_L_M_odd_g[det_lit,s_s,ib,1,flag-1]= $
								XF_L_M_odd_g[det_lit,s_s,ib,1,flag-1]/count2
							CNR_M_odd_g[det_lit,s_s,ib,1,flag-1]= $
								CNR_M_odd_g[det_lit,s_s,ib,1,flag-1]/count2
							PVP_M_odd_g[det_lit,s_s,ib,1,flag-1]= $
								PVP_M_odd_g[det_lit,s_s,ib,1,flag-1]/count2
							XF_dn_M_even_g[det_lit,s_s,ib,1,flag-1]= $
								XF_dn_M_even_g[det_lit,s_s,ib,1,flag-1]/count2
							XF_L_M_even_g[det_lit,s_s,ib,1,flag-1]= $
								XF_L_M_even_g[det_lit,s_s,ib,1,flag-1]/count2
							CNR_M_even_g[det_lit,s_s,ib,1,flag-1]= $
								CNR_M_even_g[det_lit,s_s,ib,1,flag-1]/count2
							PVP_M_even_g[det_lit,s_s,ib,1,flag-1]= $
								PVP_M_even_g[det_lit,s_s,ib,1,flag-1]/count2
						ENDIF
						IF flag EQ 1 THEN BEGIN
							count=0
							count2=0
							FOR id=0, ndet_M-1 DO BEGIN
								IF count EQ 0 THEN BEGIN
									XF_dn_M_odd_g[det_lit,s_s,ib,0,flag-1]= $
										XF_dn_M_odd_g[det_lit,s_s,ib,0,flag-1] $
										+XF_dn_M[det_lit,s_s,ib,id]
									XF_L_M_odd_g[det_lit,s_s,ib,0,flag-1]= $
										XF_L_M_odd_g[det_lit,s_s,ib,0,flag-1] $
										+XF_L_M[det_lit,s_s,ib,id]
									CNR_M_odd_g[det_lit,s_s,ib,0,flag-1]= $
										CNR_M_odd_g[det_lit,s_s,ib,0,flag-1] $
										+CNR_M[det_lit,s_s,ib,id]
									PVP_M_odd_g[det_lit,s_s,ib,0,flag-1]= $
										PVP_M_odd_g[det_lit,s_s,ib,0,flag-1] $
										+PVP_M[det_lit,s_s,ib,id]
									count=1
									count2=count2+1
									goto,skip_over_5
								ENDIF
								IF count EQ 1 THEN BEGIN
									XF_dn_M_even_g[det_lit,s_s,ib,0,flag-1]= $
										XF_dn_M_even_g[det_lit,s_s,ib,0,flag-1] $
										+XF_dn_M[det_lit,s_s,ib,id]
									XF_L_M_even_g[det_lit,s_s,ib,0,flag-1]= $
										XF_L_M_even_g[det_lit,s_s,ib,0,flag-1] $
										+XF_L_M[det_lit,s_s,ib,id]
									CNR_M_even_g[det_lit,s_s,ib,0,flag-1]= $
										CNR_M_even_g[det_lit,s_s,ib,0,flag-1] $
										+CNR_M[det_lit,s_s,ib,id]
									PVP_M_even_g[det_lit,s_s,ib,0,flag-1]= $
										PVP_M_even_g[det_lit,s_s,ib,0,flag-1] $
										+PVP_M[det_lit,s_s,ib,id]
									count=0
								ENDIF
								skip_over_5:
							ENDFOR
							XF_dn_M_odd_g[det_lit,s_s,ib,0,flag-1]= $
								XF_dn_M_odd_g[det_lit,s_s,ib,0,flag-1]/count2
							XF_L_M_odd_g[det_lit,s_s,ib,0,flag-1]= $
								XF_L_M_odd_g[det_lit,s_s,ib,0,flag-1]/count2
							CNR_M_odd_g[det_lit,s_s,ib,0,flag-1]= $
								CNR_M_odd_g[det_lit,s_s,ib,0,flag-1]/count2
							PVP_M_odd_g[det_lit,s_s,ib,0,flag-1]= $
								PVP_M_odd_g[det_lit,s_s,ib,0,flag-1]/count2
							XF_dn_M_even_g[det_lit,s_s,ib,0,flag-1]= $
								XF_dn_M_even_g[det_lit,s_s,ib,0,flag-1]/count2
							XF_L_M_even_g[det_lit,s_s,ib,0,flag-1]= $
								XF_L_M_even_g[det_lit,s_s,ib,0,flag-1]/count2
							CNR_M_even_g[det_lit,s_s,ib,0,flag-1]= $
								CNR_M_even_g[det_lit,s_s,ib,0,flag-1]/count2
							PVP_M_even_g[det_lit,s_s,ib,0,flag-1]= $
								PVP_M_even_g[det_lit,s_s,ib,0,flag-1]/count2
							XF_dn_M_odd_g[det_lit,s_s,ib,1,flag-1]=-999
							XF_L_M_odd_g[det_lit,s_s,ib,1,flag-1]=-999
							CNR_M_odd_g[det_lit,s_s,ib,1,flag-1]=-999
							PVP_M_odd_g[det_lit,s_s,ib,1,flag-1]=-999
							XF_dn_M_even_g[det_lit,s_s,ib,1,flag-1]=-999
							XF_L_M_even_g[det_lit,s_s,ib,1,flag-1]=-999
							CNR_M_even_g[det_lit,s_s,ib,1,flag-1]=-999
							PVP_M_even_g[det_lit,s_s,ib,1,flag-1]=-999
						ENDIF	
					ENDELSE
				ENDFOR
			ENDFOR
		ENDIF

		skip_col:

	ENDFOR

	IF uaid EQ 2 OR uaid EQ 5 THEN n_s=2
	IF uaid NE 2 AND uaid NE 5 THEN n_s=1
	IF uaid EQ 2 OR uaid EQ 5 THEN n_det=32
	IF uaid NE 2 AND uaid NE 5 THEN n_det=16

;*****************************************************************************
;  Write to a file.
;*****************************************************************************

	IF uaid NE 8 AND uaid NE 9 THEN BEGIN
		FOR s_s=0, n_s-1 DO BEGIN
			FOR s_det=0, n_det-1 DO BEGIN
				printf,lun,XF_dn_M_odd[s_det,s_s,3],XF_dn_M_even[s_det,s_s,3],XF_dn_M_odd[s_det,s_s,2], $
					XF_dn_M_even[s_det,s_s,2],XF_dn_I_odd[s_det,s_s,1,0],XF_dn_I_even[s_det,s_s,1,0], $
					XF_dn_I_odd[s_det,s_s,1,1],XF_dn_I_even[s_det,s_s,1,1],XF_dn_I_odd[s_det,s_s,0,0], $
					XF_dn_I_even[s_det,s_s,0,0],XF_dn_I_odd[s_det,s_s,0,1],XF_dn_I_even[s_det,s_s,0,1], $
					XF_dn_M_odd[s_det,s_s,0],XF_dn_M_even[s_det,s_s,0],XF_dn_M_odd[s_det,s_s,1], $
					XF_dn_M_even[s_det,s_s,1],XF_dn_M_odd[s_det,s_s,4],XF_dn_M_even[s_det,s_s,4], $
					XF_dn_M_odd[s_det,s_s,5],XF_dn_M_even[s_det,s_s,5],format=fmt
				printf,lon,XF_L_M_odd[s_det,s_s,3],XF_L_M_even[s_det,s_s,3],XF_L_M_odd[s_det,s_s,2], $
					XF_L_M_even[s_det,s_s,2],XF_L_I_odd[s_det,s_s,1,0],XF_L_I_even[s_det,s_s,1,0], $
					XF_L_I_odd[s_det,s_s,1,1],XF_L_I_even[s_det,s_s,1,1],XF_L_I_odd[s_det,s_s,0,0], $
					XF_L_I_even[s_det,s_s,0,0],XF_L_I_odd[s_det,s_s,0,1],XF_L_I_even[s_det,s_s,0,1], $
					XF_L_M_odd[s_det,s_s,0],XF_L_M_even[s_det,s_s,0],XF_L_M_odd[s_det,s_s,1], $
					XF_L_M_even[s_det,s_s,1],XF_L_M_odd[s_det,s_s,4],XF_L_M_even[s_det,s_s,4], $
					XF_L_M_odd[s_det,s_s,5],XF_L_M_even[s_det,s_s,5],format=fmt
				printf,len,CNR_M_odd[s_det,s_s,3],CNR_M_even[s_det,s_s,3],CNR_M_odd[s_det,s_s,2], $
					CNR_M_even[s_det,s_s,2],CNR_I_odd[s_det,s_s,1,0],CNR_I_even[s_det,s_s,1,0], $
					CNR_I_odd[s_det,s_s,1,1],CNR_I_even[s_det,s_s,1,1],CNR_I_odd[s_det,s_s,0,0], $
					CNR_I_even[s_det,s_s,0,0],CNR_I_odd[s_det,s_s,0,1],CNR_I_even[s_det,s_s,0,1], $
					CNR_M_odd[s_det,s_s,0],CNR_M_even[s_det,s_s,0],CNR_M_odd[s_det,s_s,1], $
					CNR_M_even[s_det,s_s,1],CNR_M_odd[s_det,s_s,4],CNR_M_even[s_det,s_s,4], $
					CNR_M_odd[s_det,s_s,5],CNR_M_even[s_det,s_s,5],format=fmt
				printf,lin,PVP_M_odd[s_det,s_s,3],PVP_M_even[s_det,s_s,3],PVP_M_odd[s_det,s_s,2], $
					PVP_M_even[s_det,s_s,2],PVP_I_odd[s_det,s_s,1,0],PVP_I_even[s_det,s_s,1,0], $
					PVP_I_odd[s_det,s_s,1,1],PVP_I_even[s_det,s_s,1,1],PVP_I_odd[s_det,s_s,0,0], $
					PVP_I_even[s_det,s_s,0,0],PVP_I_odd[s_det,s_s,0,1],PVP_I_even[s_det,s_s,0,1], $
					PVP_M_odd[s_det,s_s,0],PVP_M_even[s_det,s_s,0],PVP_M_odd[s_det,s_s,1], $
					PVP_M_even[s_det,s_s,1],PVP_M_odd[s_det,s_s,4],PVP_M_even[s_det,s_s,4], $
					PVP_M_odd[s_det,s_s,5],PVP_M_even[s_det,s_s,5],format=fmt
			ENDFOR
		ENDFOR
	ENDIF ELSE BEGIN
		FOR iflag=0, 1 DO BEGIN
			FOR s_s=0, n_s-1 DO BEGIN
				FOR s_det=0, n_det-1 DO BEGIN
					printf,lun,XF_dn_M_odd_g[s_det,s_s,3,1-iflag,1],XF_dn_M_even_g[s_det,s_s,3,1-iflag,1], $
						XF_dn_M_odd_g[s_det,s_s,2,1-iflag,1],XF_dn_M_even_g[s_det,s_s,2,1-iflag,1], $
						XF_dn_I_odd_g[s_det,s_s,1,0,1-iflag,1],XF_dn_I_even_g[s_det,s_s,1,0,1-iflag,1], $
						XF_dn_I_odd_g[s_det,s_s,1,1,1-iflag,1],XF_dn_I_even_g[s_det,s_s,1,1,1-iflag,1], $
						XF_dn_I_odd_g[s_det,s_s,0,0,1-iflag,1],XF_dn_I_even_g[s_det,s_s,0,0,1-iflag,1], $
						XF_dn_I_odd_g[s_det,s_s,0,1,1-iflag,1],XF_dn_I_even_g[s_det,s_s,0,1,1-iflag,1], $
						XF_dn_M_odd_g[s_det,s_s,0,1-iflag,1],XF_dn_M_even_g[s_det,s_s,0,1-iflag,1], $
						XF_dn_M_odd_g[s_det,s_s,1,1-iflag,1],XF_dn_M_even_g[s_det,s_s,1,1-iflag,1], $
						XF_dn_M_odd_g[s_det,s_s,4,1-iflag,1],XF_dn_M_even_g[s_det,s_s,4,1-iflag,1], $
						XF_dn_M_odd_g[s_det,s_s,5,1-iflag,1],XF_dn_M_even_g[s_det,s_s,5,1-iflag,1], $
						format=fmt
					printf,lon,XF_L_M_odd_g[s_det,s_s,3,1-iflag,1],XF_L_M_even_g[s_det,s_s,3,1-iflag,1], $
						XF_L_M_odd_g[s_det,s_s,2,1-iflag,1],XF_L_M_even_g[s_det,s_s,2,1-iflag,1], $
						XF_L_I_odd_g[s_det,s_s,1,0,1-iflag,1],XF_L_I_even_g[s_det,s_s,1,0,1-iflag,1], $
						XF_L_I_odd_g[s_det,s_s,1,1,1-iflag,1],XF_L_I_even_g[s_det,s_s,1,1,1-iflag,1], $
						XF_L_I_odd_g[s_det,s_s,0,0,1-iflag,1],XF_L_I_even_g[s_det,s_s,0,0,1-iflag,1], $
						XF_L_I_odd_g[s_det,s_s,0,1,1-iflag,1],XF_L_I_even_g[s_det,s_s,0,1,1-iflag,1], $
						XF_L_M_odd_g[s_det,s_s,0,1-iflag,1],XF_L_M_even_g[s_det,s_s,0,1-iflag,1], $
						XF_L_M_odd_g[s_det,s_s,1,1-iflag,1],XF_L_M_even_g[s_det,s_s,1,1-iflag,1], $
						XF_L_M_odd_g[s_det,s_s,4,1-iflag,1],XF_L_M_even_g[s_det,s_s,4,1-iflag,1], $
						XF_L_M_odd_g[s_det,s_s,5,1-iflag,1],XF_L_M_even_g[s_det,s_s,5,1-iflag,1], $
						format=fmt
					printf,len,CNR_M_odd_g[s_det,s_s,3,1-iflag,1],CNR_M_even_g[s_det,s_s,3,1-iflag,1], $
						CNR_M_odd_g[s_det,s_s,2,1-iflag,1],CNR_M_even_g[s_det,s_s,2,1-iflag,1], $
						CNR_I_odd_g[s_det,s_s,1,0,1-iflag,1],CNR_I_even_g[s_det,s_s,1,0,1-iflag,1], $
						CNR_I_odd_g[s_det,s_s,1,1,1-iflag,1],CNR_I_even_g[s_det,s_s,1,1,1-iflag,1], $
						CNR_I_odd_g[s_det,s_s,0,0,1-iflag,1],CNR_I_even_g[s_det,s_s,0,0,1-iflag,1], $
						CNR_I_odd_g[s_det,s_s,0,1,1-iflag,1],CNR_I_even_g[s_det,s_s,0,1,1-iflag,1], $
						CNR_M_odd_g[s_det,s_s,0,1-iflag,1],CNR_M_even_g[s_det,s_s,0,1-iflag,1], $
						CNR_M_odd_g[s_det,s_s,1,1-iflag,1],CNR_M_even_g[s_det,s_s,1,1-iflag,1], $
						CNR_M_odd_g[s_det,s_s,4,1-iflag,1],CNR_M_even_g[s_det,s_s,4,1-iflag,1], $
						CNR_M_odd_g[s_det,s_s,5,1-iflag,1],CNR_M_even_g[s_det,s_s,5,1-iflag,1], $
						format=fmt
					printf,lin,PVP_M_odd_g[s_det,s_s,3,1-iflag,1],PVP_M_even_g[s_det,s_s,3,1-iflag,1], $
						PVP_M_odd_g[s_det,s_s,2,1-iflag,1],PVP_M_even_g[s_det,s_s,2,1-iflag,1], $
						PVP_I_odd_g[s_det,s_s,1,0,1-iflag,1],PVP_I_even_g[s_det,s_s,1,0,1-iflag,1], $
						PVP_I_odd_g[s_det,s_s,1,1,1-iflag,1],PVP_I_even_g[s_det,s_s,1,1,1-iflag,1], $
						PVP_I_odd_g[s_det,s_s,0,0,1-iflag,1],PVP_I_even_g[s_det,s_s,0,0,1-iflag,1], $
						PVP_I_odd_g[s_det,s_s,0,1,1-iflag,1],PVP_I_even_g[s_det,s_s,0,1,1-iflag,1], $
						PVP_M_odd_g[s_det,s_s,0,1-iflag,1],PVP_M_even_g[s_det,s_s,0,1-iflag,1], $
						PVP_M_odd_g[s_det,s_s,1,1-iflag,1],PVP_M_even_g[s_det,s_s,1,1-iflag,1], $
						PVP_M_odd_g[s_det,s_s,4,1-iflag,1],PVP_M_even_g[s_det,s_s,4,1-iflag,1], $
						PVP_M_odd_g[s_det,s_s,5,1-iflag,1],PVP_M_even_g[s_det,s_s,5,1-iflag,1], $
						format=fmt
					printf,lun_2,XF_dn_M_odd_g[s_det,s_s,3,1-iflag,0], $
						XF_dn_M_even_g[s_det,s_s,3,1-iflag,0], $
						XF_dn_M_odd_g[s_det,s_s,2,1-iflag,0],XF_dn_M_even_g[s_det,s_s,2,1-iflag,0], $
						XF_dn_I_odd_g[s_det,s_s,1,0,1-iflag,0],XF_dn_I_even_g[s_det,s_s,1,0,1-iflag,0], $
						XF_dn_I_odd_g[s_det,s_s,1,1,1-iflag,0],XF_dn_I_even_g[s_det,s_s,1,1,1-iflag,0], $
						XF_dn_I_odd_g[s_det,s_s,0,0,1-iflag,0],XF_dn_I_even_g[s_det,s_s,0,0,1-iflag,0], $
						XF_dn_I_odd_g[s_det,s_s,0,1,1-iflag,0],XF_dn_I_even_g[s_det,s_s,0,1,1-iflag,0], $
						XF_dn_M_odd_g[s_det,s_s,0,1-iflag,0],XF_dn_M_even_g[s_det,s_s,0,1-iflag,0], $
						XF_dn_M_odd_g[s_det,s_s,1,1-iflag,0],XF_dn_M_even_g[s_det,s_s,1,1-iflag,0], $
						XF_dn_M_odd_g[s_det,s_s,4,1-iflag,0],XF_dn_M_even_g[s_det,s_s,4,1-iflag,0], $
						XF_dn_M_odd_g[s_det,s_s,5,1-iflag,0],XF_dn_M_even_g[s_det,s_s,5,1-iflag,0], $
						format=fmt
					printf,lon_2,XF_L_M_odd_g[s_det,s_s,3,1-iflag,0],XF_L_M_even_g[s_det,s_s,3,1-iflag,0], $
						XF_L_M_odd_g[s_det,s_s,2,1-iflag,0],XF_L_M_even_g[s_det,s_s,2,1-iflag,0], $
						XF_L_I_odd_g[s_det,s_s,1,0,1-iflag,0],XF_L_I_even_g[s_det,s_s,1,0,1-iflag,0], $
						XF_L_I_odd_g[s_det,s_s,1,1,1-iflag,0],XF_L_I_even_g[s_det,s_s,1,1,1-iflag,0], $
						XF_L_I_odd_g[s_det,s_s,0,0,1-iflag,0],XF_L_I_even_g[s_det,s_s,0,0,1-iflag,0], $
						XF_L_I_odd_g[s_det,s_s,0,1,1-iflag,0],XF_L_I_even_g[s_det,s_s,0,1,1-iflag,0], $
						XF_L_M_odd_g[s_det,s_s,0,1-iflag,0],XF_L_M_even_g[s_det,s_s,0,1-iflag,0], $
						XF_L_M_odd_g[s_det,s_s,1,1-iflag,0],XF_L_M_even_g[s_det,s_s,1,1-iflag,0], $
						XF_L_M_odd_g[s_det,s_s,4,1-iflag,0],XF_L_M_even_g[s_det,s_s,4,1-iflag,0], $
						XF_L_M_odd_g[s_det,s_s,5,1-iflag,0],XF_L_M_even_g[s_det,s_s,5,1-iflag,0], $
						format=fmt
					printf,len_2,CNR_M_odd_g[s_det,s_s,3,1-iflag,0],CNR_M_even_g[s_det,s_s,3,1-iflag,0], $
						CNR_M_odd_g[s_det,s_s,2,1-iflag,0],CNR_M_even_g[s_det,s_s,2,1-iflag,0], $
						CNR_I_odd_g[s_det,s_s,1,0,1-iflag,0],CNR_I_even_g[s_det,s_s,1,0,1-iflag,0], $
						CNR_I_odd_g[s_det,s_s,1,1,1-iflag,0],CNR_I_even_g[s_det,s_s,1,1,1-iflag,0], $
						CNR_I_odd_g[s_det,s_s,0,0,1-iflag,0],CNR_I_even_g[s_det,s_s,0,0,1-iflag,0], $
						CNR_I_odd_g[s_det,s_s,0,1,1-iflag,0],CNR_I_even_g[s_det,s_s,0,1,1-iflag,0], $
						CNR_M_odd_g[s_det,s_s,0,1-iflag,0],CNR_M_even_g[s_det,s_s,0,1-iflag,0], $
						CNR_M_odd_g[s_det,s_s,1,1-iflag,0],CNR_M_even_g[s_det,s_s,1,1-iflag,0], $
						CNR_M_odd_g[s_det,s_s,4,1-iflag,0],CNR_M_even_g[s_det,s_s,4,1-iflag,0], $
						CNR_M_odd_g[s_det,s_s,5,1-iflag,0],CNR_M_even_g[s_det,s_s,5,1-iflag,0], $
						format=fmt
					printf,lin_2,PVP_M_odd_g[s_det,s_s,3,1-iflag,0],PVP_M_even_g[s_det,s_s,3,1-iflag,0], $
						PVP_M_odd_g[s_det,s_s,2,1-iflag,0],PVP_M_even_g[s_det,s_s,2,1-iflag,0], $
						PVP_I_odd_g[s_det,s_s,1,0,1-iflag,0],PVP_I_even_g[s_det,s_s,1,0,1-iflag,0], $
						PVP_I_odd_g[s_det,s_s,1,1,1-iflag,0],PVP_I_even_g[s_det,s_s,1,1,1-iflag,0], $
						PVP_I_odd_g[s_det,s_s,0,0,1-iflag,0],PVP_I_even_g[s_det,s_s,0,0,1-iflag,0], $
						PVP_I_odd_g[s_det,s_s,0,1,1-iflag,0],PVP_I_even_g[s_det,s_s,0,1,1-iflag,0], $
						PVP_M_odd_g[s_det,s_s,0,1-iflag,0],PVP_M_even_g[s_det,s_s,0,1-iflag,0], $
						PVP_M_odd_g[s_det,s_s,1,1-iflag,0],PVP_M_even_g[s_det,s_s,1,1-iflag,0], $
						PVP_M_odd_g[s_det,s_s,4,1-iflag,0],PVP_M_even_g[s_det,s_s,4,1-iflag,0], $
						PVP_M_odd_g[s_det,s_s,5,1-iflag,0],PVP_M_even_g[s_det,s_s,5,1-iflag,0], $
						format=fmt
				ENDFOR
			ENDFOR
		ENDFOR
	ENDELSE

	Free_Lun,lun
	close,/all

	skip_loop:
ENDFOR

close,/all

END
