;*****************************************************************************
;				NICST TOOL
;
;  FP-13 Static SMWIR Xtalk test. Reform XF_dn, XF_L, CNR, and PVP data to
;  fit into the point-to-point crosstalk table.
;  
;  v1.0 - 1/23/2008 - Jeff McIntire
;*****************************************************************************

PRO reform_SMWIR

close,/all

ndet_I=32
ndet_M=16

uaidname=['3102097','3102104','3102107','3102118','3102124','3102150','3102163','3102164','3102165','3102168','3102193']
n_uaid=N_ELEMENTS(uaidname)
colnum=[33,36,69,33,39,66,8,28,57,49,33]

fmt='(i3, 5x, i3, 5x, i3, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13)'
fmt2='(i3, 5x, i3, 5x, i3, 5x, i3, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13, 5x, d13)'

FOR uaid=0, n_uaid-1 DO BEGIN

;*****************************************************************************
;  Create output files.
;*****************************************************************************

	IF uaid NE 8 AND uaid NE 9 THEN BEGIN
		outfname1='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.reform.coeff.dn.dat'
		outfname2='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.reform.coeff.L.dat'
		outfname3='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.reform.coeff.CNR.dat'
		outfname4='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.reform.coeff.PVP.dat'
		openw,lun,outfname1,/get_lun
		openw,lon,outfname2,/get_lun
		openw,len,outfname3,/get_lun
		openw,lin,outfname4,/get_lun
		printf,lun,'s_s  s_det  id  M13  M12  I4_SS1  I4_SS2  I3_SS1  I3_SS2  M10  M11  M8  M9'
		printf,lon,'s_s  s_det  id  M13  M12  I4_SS1  I4_SS2  I3_SS1  I3_SS2  M10  M11  M8  M9'
		printf,len,'s_s  s_det  id  M13  M12  I4_SS1  I4_SS2  I3_SS1  I3_SS2  M10  M11  M8  M9'
		printf,lin,'s_s  s_det  id  M13  M12  I4_SS1  I4_SS2  I3_SS1  I3_SS2  M10  M11  M8  M9'
	ENDIF
	IF uaid EQ 8 OR uaid EQ 9 THEN BEGIN
		outfname1='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.reform.coeff.dn.alg.dat'
		outfname4='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.reform.coeff.dn.flg.dat'
		outfname2='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.reform.coeff.L.alg.dat'
		outfname5='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.reform.coeff.L.flg.dat'
		outfname3='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.reform.coeff.CNR.alg.dat'
		outfname6='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.reform.coeff.CNR.flg.dat'
		outfname7='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.reform.coeff.PVP.alg.dat'
		outfname8='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.reform.coeff.PVP.flg.dat'
		openw,lun,outfname1,/get_lun
		openw,lon,outfname2,/get_lun
		openw,len,outfname3,/get_lun
		openw,lin,outfname7,/get_lun
		openw,lun_2,outfname4,/get_lun
		openw,lon_2,outfname5,/get_lun
		openw,len_2,outfname6,/get_lun
		openw,lin_2,outfname8,/get_lun
		printf,lun,'s_s  s_det  id  M13  M12  I4_SS1  I4_SS2  I3_SS1  I3_SS2  M10  M11  M8  M9'
		printf,lon,'s_s  s_det  id  M13  M12  I4_SS1  I4_SS2  I3_SS1  I3_SS2  M10  M11  M8  M9'
		printf,len,'s_s  s_det  id  M13  M12  I4_SS1  I4_SS2  I3_SS1  I3_SS2  M10  M11  M8  M9'
		printf,lin,'s_s  s_det  id  M13  M12  I4_SS1  I4_SS2  I3_SS1  I3_SS2  M10  M11  M8  M9'
		printf,lun_2,'s_s  s_det  id  M13  M12  I4_SS1  I4_SS2  I3_SS1  I3_SS2  M10  M11  M8  M9'
		printf,lon_2,'s_s  s_det  id  M13  M12  I4_SS1  I4_SS2  I3_SS1  I3_SS2  M10  M11  M8  M9'
		printf,len_2,'s_s  s_det  id  M13  M12  I4_SS1  I4_SS2  I3_SS1  I3_SS2  M10  M11  M8  M9'
		printf,lin_2,'s_s  s_det  id  M13  M12  I4_SS1  I4_SS2  I3_SS1  I3_SS2  M10  M11  M8  M9'
	ENDIF

;*****************************************************************************
;  Input data for I and M bands.
;*****************************************************************************

	infname1='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.dn.sav'
;	infname2='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.coeff.sav';
	infname2='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.snd_avg_coeff.sav'
	check=FILE_SEARCH(infname1)
	IF check EQ '' THEN BEGIN
		print,'No file is found.',infname1
		goto,skip_loop
	ENDIF
	print,'Processing file:',infname1
	print,'Processing file:',infname2
	restore,infname1
	restore,infname2

	; reformed data
	XF_dn_I_r=fltarr(ndet_I,2,2,ndet_I,2)
	XF_L_I_r=fltarr(ndet_I,2,2,ndet_I,2)
	CNR_I_r=fltarr(ndet_I,2,2,ndet_I,2)
	PVP_I_r=fltarr(ndet_I,2,2,ndet_I,2)
	XF_dn_M_r=fltarr(ndet_I,2,6,ndet_I)
	XF_L_M_r=fltarr(ndet_I,2,6,ndet_I)
	CNR_M_r=fltarr(ndet_I,2,6,ndet_I)
	PVP_M_r=fltarr(ndet_I,2,6,ndet_I)

	XF_dn_I_t=fltarr(2,2,2)
	XF_L_I_t=fltarr(2,2,2)
	CNR_I_t=fltarr(2,2,2)
	PVP_I_t=fltarr(2,2,2)
	XF_dn_M_t=fltarr(2)
	XF_L_M_t=fltarr(2)
	CNR_M_t=fltarr(2)
	PVP_M_t=fltarr(2)
	XF_dn_M_t_g=fltarr(2,2)
	XF_L_M_t_g=fltarr(2,2)
	CNR_M_t_g=fltarr(2,2)
	PVP_M_t_g=fltarr(2,2)

	; reformed data for dual gain bands
	XF_dn_I_g=fltarr(ndet_I,2,2,ndet_I,2,2,2)
	XF_L_I_g=fltarr(ndet_I,2,2,ndet_I,2,2,2)
	CNR_I_g=fltarr(ndet_I,2,2,ndet_I,2,2,2)
	PVP_I_g=fltarr(ndet_I,2,2,ndet_I,2,2,2)
	XF_dn_M_g=fltarr(ndet_I,2,6,ndet_I,2,2)
	XF_L_M_g=fltarr(ndet_I,2,6,ndet_I,2,2)
	CNR_M_g=fltarr(ndet_I,2,6,ndet_I,2,2)
	PVP_M_g=fltarr(ndet_I,2,6,ndet_I,2,2)

	count1=0
	count2=0
	FOR col=0, colnum[uaid]-1 DO BEGIN
		flag=0

		; U3102097
		IF uaid EQ 0 THEN BEGIN
			IF col EQ 16 THEN goto,skip_col
		ENDIF

		; U3102104
		IF uaid EQ 1 THEN BEGIN
			IF col EQ 18 OR col EQ 19 OR col EQ 22 OR col EQ 23 THEN goto,skip_col
		ENDIF

		; U3102107
		IF uaid EQ 2 THEN BEGIN
			IF col EQ 4 OR col EQ 23 OR col EQ 24 OR col EQ 41 OR col EQ 64 THEN goto,skip_col
		ENDIF

		; U3102118
		IF uaid EQ 3 THEN BEGIN
			IF col EQ 4 THEN goto,skip_col
		ENDIF

		; U3102124
		IF uaid EQ 4 THEN BEGIN
			IF col EQ 0 OR col EQ 1 OR col EQ 2 OR col EQ 4 OR col EQ 6 OR col EQ 7 $
				OR col EQ 8 OR col EQ 10 OR col EQ 12 OR col EQ 14 OR col EQ 15 $
				OR col EQ 17 OR col EQ 19 OR col EQ 21 OR col EQ 23 OR col EQ 25 $
				OR col EQ 26 OR col EQ 28 OR col EQ 30 OR col EQ 32 OR col EQ 34 $
				OR col EQ 36 OR col EQ 38 THEN goto,skip_col
		ENDIF

		; U3102150
		IF uaid EQ 5 THEN BEGIN
			IF col EQ 0 OR col EQ 53 THEN goto,skip_col
		ENDIF

		; U3102163
		IF uaid EQ 6 THEN BEGIN
			IF col EQ 0 OR col EQ 1 OR col EQ 3 OR col EQ 4 OR col EQ 5 OR col EQ 7 $
				THEN goto,skip_col
		ENDIF

		; U3102164
		IF uaid EQ 7 THEN BEGIN
			IF col EQ 1 OR col EQ 3 OR col EQ 5 OR col EQ 7 OR col EQ 9 OR col EQ 11 $
				OR col EQ 13 OR col EQ 15 OR col EQ 17 OR col EQ 19 OR col EQ 21 $
				OR col EQ 23 OR col EQ 25 OR col EQ 27 THEN goto,skip_col
		ENDIF

		; U3102165
		IF uaid EQ 8 THEN BEGIN
			IF col EQ 1 OR col EQ 4 OR col EQ 7 OR col EQ 10 OR col EQ 13 OR col EQ 15 $
				OR col EQ 17 OR col EQ 20 OR col EQ 23 OR col EQ 25 OR col EQ 26 $
				OR col EQ 27 OR col EQ 29 OR col EQ 32 OR col EQ 35 OR col EQ 38 $
				OR col EQ 41 OR col EQ 44 OR col EQ 46 OR col EQ 47 OR col EQ 48 $
				OR col EQ 49 OR col EQ 50 OR col EQ 52 OR col EQ 55 THEN goto,skip_col
		ENDIF
		; U3102165 auto low collects
		IF uaid EQ 8 THEN BEGIN
			IF col EQ 0 OR col EQ 3 OR col EQ 6 OR col EQ 9 OR col EQ 12 OR col EQ 16 $
				OR col EQ 19 OR col EQ 22 OR col EQ 28 OR col EQ 31 OR col EQ 34 $
				OR col EQ 37 OR col EQ 40 OR col EQ 43 OR col EQ 51 OR col EQ 54 THEN flag=2
		ENDIF
		; U3102165 fixed low collects
		IF uaid EQ 8 THEN BEGIN
			IF col EQ 2 OR col EQ 5 OR col EQ 8 OR col EQ 11 OR col EQ 14 OR col EQ 18 $
				OR col EQ 21 OR col EQ 24 OR col EQ 30 OR col EQ 33 OR col EQ 36 $
				OR col EQ 39 OR col EQ 42 OR col EQ 45 OR col EQ 53 OR col EQ 56 THEN flag=1
		ENDIF

		; U3102168
		IF uaid EQ 9 THEN BEGIN
			IF col EQ 0 OR col EQ 1 OR col EQ 5 OR col EQ 8 OR col EQ 11 OR col EQ 14 $
				OR col EQ 17 OR col EQ 20 OR col EQ 23 OR col EQ 26 OR col EQ 29 $
				OR col EQ 32 OR col EQ 35 OR col EQ 38 OR col EQ 41 OR col EQ 44 $
				OR col EQ 47 THEN goto,skip_col
		ENDIF
		; U3102168 auto low collects
		IF uaid EQ 9 THEN BEGIN
			IF col EQ 3 OR col EQ 4 OR col EQ 7 OR col EQ 10 OR col EQ 13 OR col EQ 16 $
				OR col EQ 19 OR col EQ 22 OR col EQ 25 OR col EQ 28 OR col EQ 31 $
				OR col EQ 34 OR col EQ 37 OR col EQ 40 OR col EQ 43 OR col EQ 46 THEN flag=2
		ENDIF
		; U3102168 fixed low collects
		IF uaid EQ 9 THEN BEGIN
			IF col EQ 2 OR col EQ 6 OR col EQ 9 OR col EQ 12 OR col EQ 15 OR col EQ 18 $
				OR col EQ 21 OR col EQ 24 OR col EQ 27 OR col EQ 30 OR col EQ 33 $
				OR col EQ 36 OR col EQ 39 OR col EQ 42 OR col EQ 45 OR col EQ 48 THEN flag=1
		ENDIF

		; U3102193
		IF uaid EQ 10 THEN BEGIN
			IF col EQ 0 THEN goto,skip_col
		ENDIF

;*****************************************************************************
;  Reform data into appropriate format.
;*****************************************************************************

		band_lit=fix(high_det[col,0])
		det_lit=fix(high_det[col,1])

		XF_dn_I=fltarr(ndet_I,2,2,ndet_I,2)
		XF_L_I=fltarr(ndet_I,2,2,ndet_I,2)
		CNR_I=fltarr(ndet_I,2,2,ndet_I,2)
		PVP_I=fltarr(ndet_I,2,2,ndet_I,2)
		FOR j=0, 1 DO BEGIN
			FOR i=0, ndet_I-1, 2 DO BEGIN
				XF_dn_I[*,*,j,i,0]=XF_dn[col,*,*,j,i,0]
				XF_dn_I[*,*,j,i+1,0]=XF_dn[col,*,*,j,i+1,1]
				XF_dn_I[*,*,j,i,1]=XF_dn[col,*,*,j,i,1]
				XF_dn_I[*,*,j,i+1,1]=XF_dn[col,*,*,j,i+1,0]

				XF_L_I[*,*,j,i,0]=XF_L[col,*,*,j,i,0]
				XF_L_I[*,*,j,i+1,0]=XF_L[col,*,*,j,i+1,1]
				XF_L_I[*,*,j,i,1]=XF_L[col,*,*,j,i,1]
				XF_L_I[*,*,j,i+1,1]=XF_L[col,*,*,j,i+1,0]

				CNR_I[*,*,j,i,0]=CNR[col,*,*,j,i,0]
				CNR_I[*,*,j,i+1,0]=CNR[col,*,*,j,i+1,1]
				CNR_I[*,*,j,i,1]=CNR[col,*,*,j,i,1]
				CNR_I[*,*,j,i+1,1]=CNR[col,*,*,j,i+1,0]

				PVP_I[*,*,j,i,0]=PVP[col,*,*,j,i,0]
				PVP_I[*,*,j,i+1,0]=PVP[col,*,*,j,i+1,1]
				PVP_I[*,*,j,i,1]=PVP[col,*,*,j,i,1]
				PVP_I[*,*,j,i+1,1]=PVP[col,*,*,j,i+1,0]
			ENDFOR
		ENDFOR

		XF_dn_M=(reform(XF_dn[col,*,*,2:7,0:15,0]))
		XF_L_M=(reform(XF_L[col,*,*,2:7,0:15,0]))
		CNR_M=(reform(CNR[col,*,*,2:7,0:15,0]))
		PVP_M=(reform(PVP[col,*,*,2:7,0:15,0]))

		XF_dn_I_tt=fltarr(ndet_I,2,2,ndet_I,2)
		XF_L_I_tt=fltarr(ndet_I,2,2,ndet_I,2)
		CNR_I_tt=fltarr(ndet_I,2,2,ndet_I,2)
		PVP_I_tt=fltarr(ndet_I,2,2,ndet_I,2)

;*****************************************************************************
;  Make the higher subsample come first.
;*****************************************************************************

		IF band_lit LE 1 THEN n_s=2
		IF band_lit GT 1 THEN n_s=1

		FOR s_s=0, n_s-1 DO BEGIN
			FOR r_s=0, 1 DO BEGIN
				FOR ib=0, 1 DO BEGIN
					IF mean(XF_L_I[det_lit,s_s,ib,*,0]) GT $
						mean(XF_L_I[det_lit,s_s,ib,*,1]) THEN BEGIN
						FOR id=0, ndet_I-1 DO BEGIN

							XF_dn_I_tt[det_lit,s_s,ib,id,0]=XF_dn_I[det_lit,s_s,ib,id,0]
							XF_dn_I_tt[det_lit,s_s,ib,id,1]=XF_dn_I[det_lit,s_s,ib,id,1]
							XF_L_I_tt[det_lit,s_s,ib,id,0]=XF_L_I[det_lit,s_s,ib,id,0]
							XF_L_I_tt[det_lit,s_s,ib,id,1]=XF_L_I[det_lit,s_s,ib,id,1]
							CNR_I_tt[det_lit,s_s,ib,id,0]=CNR_I[det_lit,s_s,ib,id,0]
							CNR_I_tt[det_lit,s_s,ib,id,1]=CNR_I[det_lit,s_s,ib,id,1]
							PVP_I_tt[det_lit,s_s,ib,id,0]=PVP_I[det_lit,s_s,ib,id,0]
							PVP_I_tt[det_lit,s_s,ib,id,1]=PVP_I[det_lit,s_s,ib,id,1]
						ENDFOR
					ENDIF
					IF mean(XF_L_I[det_lit,s_s,ib,*,1]) GT $
						mean(XF_L_I[det_lit,s_s,ib,*,0]) THEN BEGIN
						FOR id=0, ndet_I-1 DO BEGIN

							XF_dn_I_tt[det_lit,s_s,ib,id,0]=XF_dn_I[det_lit,s_s,ib,id,1]
							XF_dn_I_tt[det_lit,s_s,ib,id,1]=XF_dn_I[det_lit,s_s,ib,id,0]
							XF_L_I_tt[det_lit,s_s,ib,id,0]=XF_L_I[det_lit,s_s,ib,id,1]
							XF_L_I_tt[det_lit,s_s,ib,id,1]=XF_L_I[det_lit,s_s,ib,id,0]
							CNR_I_tt[det_lit,s_s,ib,id,0]=CNR_I[det_lit,s_s,ib,id,1]
							CNR_I_tt[det_lit,s_s,ib,id,1]=CNR_I[det_lit,s_s,ib,id,0]
							PVP_I_tt[det_lit,s_s,ib,id,0]=PVP_I[det_lit,s_s,ib,id,1]
							PVP_I_tt[det_lit,s_s,ib,id,1]=PVP_I[det_lit,s_s,ib,id,0]
						ENDFOR
					ENDIF
				ENDFOR
			ENDFOR
		ENDFOR
		XF_dn_I[*,*,*,*,*]=XF_dn_I_tt[*,*,*,*,*]
		XF_L_I[*,*,*,*,*]=XF_L_I_tt[*,*,*,*,*]
		CNR_I[*,*,*,*,*]=CNR_I_tt[*,*,*,*,*]
		PVP_I[*,*,*,*,*]=PVP_I_tt[*,*,*,*,*]

;*****************************************************************************
;  Reform I band data into appropriate format.
;*****************************************************************************

		IF uaid EQ 8 OR uaid EQ 9 THEN goto,uaid_skip
		FOR ib=0, 1 DO BEGIN
			FOR s_s=0, n_s-1 DO BEGIN
				FOR r_s=0, 1 DO BEGIN
					FOR id=0, ndet_I-1 DO BEGIN
						XF_dn_I_r[det_lit,s_s,ib,id,r_s]=XF_dn_I_r[det_lit,s_s,ib,id,r_s]+ $
							XF_dn_I[det_lit,s_s,ib,id,r_s]
						XF_L_I_r[det_lit,s_s,ib,id,r_s]=XF_L_I_r[det_lit,s_s,ib,id,r_s]+ $
							XF_L_I[det_lit,s_s,ib,id,r_s]
						CNR_I_r[det_lit,s_s,ib,id,r_s]=CNR_I_r[det_lit,s_s,ib,id,r_s]+ $
							CNR_I[det_lit,s_s,ib,id,r_s]
						PVP_I_r[det_lit,s_s,ib,id,r_s]=PVP_I_r[det_lit,s_s,ib,id,r_s]+ $
							PVP_I[det_lit,s_s,ib,id,r_s]
					ENDFOR
				ENDFOR
			ENDFOR
		ENDFOR
		count1=count1+1
		IF count1 EQ 2 THEN BEGIN
			IF uaid NE 4 AND uaid NE 6 AND uaid NE 7 THEN BEGIN
				XF_dn_I_r[det_lit,*,*,*,*]=XF_dn_I_r[det_lit,*,*,*,*]/2
				XF_L_I_r[det_lit,*,*,*,*]=XF_L_I_r[det_lit,*,*,*,*]/2
				CNR_I_r[det_lit,*,*,*,*]=CNR_I_r[det_lit,*,*,*,*]/2
				PVP_I_r[det_lit,*,*,*,*]=PVP_I_r[det_lit,*,*,*,*]/2
			ENDIF
			count1=0
		ENDIF

;*****************************************************************************
;  Include in-track correction for I bands.
;*****************************************************************************

		IF band_lit LE 1 THEN BEGIN
			FOR s_s=0, n_s-1 DO BEGIN
				FOR r_s=0, 1 DO BEGIN
					XF_dn_I_t[s_s,r_s]=0
					XF_L_I_t[s_s,r_s]=0
					CNR_I_t[s_s,r_s]=0
					PVP_I_t[s_s,r_s]=0
				ENDFOR
			ENDFOR

			IF uaid EQ 2 AND band_lit NE 0 THEN goto,skip_I3
			IF uaid EQ 5 AND band_lit NE 1 THEN goto,skip_I4

			IF uaid EQ 2 AND band_lit EQ 0 THEN det_drop=5
			IF uaid EQ 5 AND band_lit EQ 1 THEN det_drop=5

			x1=det_lit-det_drop
			x2=det_lit+det_drop

			IF x1 LT 0 THEN BEGIN
				x1=-1 
				goto,skip_x1
			ENDIF
			FOR s_s=0, n_s-1 DO BEGIN
				FOR r_s=0, 1 DO BEGIN
					FOR i=0, x1 DO BEGIN
						XF_dn_I_t[s_s,band_lit,r_s]=XF_dn_I_t[s_s,band_lit,r_s] $
							+XF_dn_I_r[det_lit,s_s,band_lit,i,r_s]
						XF_L_I_t[s_s,band_lit,r_s]=XF_L_I_t[s_s,band_lit,r_s] $
							+XF_L_I_r[det_lit,s_s,band_lit,i,r_s]
						CNR_I_t[s_s,band_lit,r_s]=CNR_I_t[s_s,band_lit,r_s] $
							+CNR_I_r[det_lit,s_s,band_lit,i,r_s]
						PVP_I_t[s_s,band_lit,r_s]=PVP_I_t[s_s,band_lit,r_s] $
							+PVP_I_r[det_lit,s_s,band_lit,i,r_s]
					ENDFOR
				ENDFOR
			ENDFOR
			skip_x1:

			IF x2 GT 31 THEN BEGIN
				x2=32 
				goto,skip_x2
			ENDIF
			FOR s_s=0, n_s-1 DO BEGIN
				FOR r_s=0, 1 DO BEGIN
					FOR i=x2, 31 DO BEGIN
						XF_dn_I_t[s_s,band_lit,r_s]=XF_dn_I_t[s_s,band_lit,r_s] $
							+XF_dn_I_r[det_lit,s_s,band_lit,i,r_s]
						XF_L_I_t[s_s,band_lit,r_s]=XF_L_I_t[s_s,band_lit,r_s] $
							+XF_L_I_r[det_lit,s_s,band_lit,i,r_s]
						CNR_I_t[s_s,band_lit,r_s]=CNR_I_t[s_s,band_lit,r_s] $
							+CNR_I_r[det_lit,s_s,band_lit,i,r_s]
						PVP_I_t[s_s,band_lit,r_s]=PVP_I_t[s_s,band_lit,r_s] $
							+PVP_I_r[det_lit,s_s,band_lit,i,r_s]
					ENDFOR
				ENDFOR
			ENDFOR
			skip_x2:

			XF_dn_I_t[*,*,*]=XF_dn_I_t[*,*,*]/(x1+33-x2)
			XF_L_I_t[*,*,*]=XF_L_I_t[*,*,*]/(x1+33-x2)
			CNR_I_t[*,*,*]=CNR_I_t[*,*,*]/(x1+33-x2)
			PVP_I_t[*,*,*]=PVP_I_t[*,*,*]/(x1+33-x2)
			
			FOR i=x1+1, x2-1 DO BEGIN
				IF i EQ det_lit THEN goto,skip_high_1

				XF_dn_I_r[det_lit,*,band_lit,i,*]=XF_dn_I_t[*,band_lit,*]
				XF_L_I_r[det_lit,*,band_lit,i,*]=XF_L_I_t[*,band_lit,*]
				CNR_I_r[det_lit,*,band_lit,i,*]=CNR_I_t[*,band_lit,*]
				PVP_I_r[det_lit,*,band_lit,i,*]=PVP_I_t[*,band_lit,*]

				skip_high_1:
			ENDFOR

			skip_I3:
			skip_I4:
			
		ENDIF

;*****************************************************************************
;  Reform M band data into appropriate format.
;*****************************************************************************

		FOR ib=0, 5 DO BEGIN
			FOR s_s=0, n_s-1 DO BEGIN
				FOR id=0, ndet_I-1 DO BEGIN
					IF id LT 16 THEN BEGIN
						XF_dn_M_r[det_lit,s_s,ib,id]=XF_dn_M_r[det_lit,s_s,ib,id]+ $
							XF_dn_M[det_lit,s_s,ib,id]
						XF_L_M_r[det_lit,s_s,ib,id]=XF_L_M_r[det_lit,s_s,ib,id]+ $
							XF_L_M[det_lit,s_s,ib,id]
						CNR_M_r[det_lit,s_s,ib,id]=CNR_M_r[det_lit,s_s,ib,id]+ $
							CNR_M[det_lit,s_s,ib,id]
						PVP_M_r[det_lit,s_s,ib,id]=PVP_M_r[det_lit,s_s,ib,id]+ $
							PVP_M[det_lit,s_s,ib,id]
					ENDIF ELSE BEGIN
						XF_dn_M_r[det_lit,s_s,ib,id]=-999
						XF_L_M_r[det_lit,s_s,ib,id]=-999
						CNR_M_r[det_lit,s_s,ib,id]=-999
						PVP_M_r[det_lit,s_s,ib,id]=-999
					ENDELSE
				ENDFOR
			ENDFOR
		ENDFOR
		count2=count2+1
		IF count2 EQ 2 THEN BEGIN
			IF uaid NE 4 AND uaid NE 6 AND uaid NE 7 THEN BEGIN
				XF_dn_M_r[det_lit,*,0:1,0:15]=XF_dn_M_r[det_lit,*,0:1,0:15]/2
				XF_dn_M_r[det_lit,*,4:5,0:15]=XF_dn_M_r[det_lit,*,4:5,0:15]/2
				XF_L_M_r[det_lit,*,0:1,0:15]=XF_L_M_r[det_lit,*,0:1,0:15]/2
				XF_L_M_r[det_lit,*,4:5,0:15]=XF_L_M_r[det_lit,*,4:5,0:15]/2
				CNR_M_r[det_lit,*,0:1,0:15]=CNR_M_r[det_lit,*,0:1,0:15]/2
				CNR_M_r[det_lit,*,4:5,0:15]=CNR_M_r[det_lit,*,4:5,0:15]/2
				PVP_M_r[det_lit,*,0:1,0:15]=PVP_M_r[det_lit,*,0:1,0:15]/2
				PVP_M_r[det_lit,*,4:5,0:15]=PVP_M_r[det_lit,*,4:5,0:15]/2
			ENDIF
			count2=0
		ENDIF

;*****************************************************************************
;  Include in-track correction for M bands.
;*****************************************************************************

		IF band_lit GT 1 THEN BEGIN
			FOR s_s=0, n_s-1 DO BEGIN
				XF_dn_M_t[s_s]=0
				XF_L_M_t[s_s]=0
				CNR_M_t[s_s]=0
				PVP_M_t[s_s]=0
			ENDFOR

			IF uaid EQ 0 AND band_lit NE 6 THEN goto,skip_M8
			IF uaid EQ 3 AND band_lit NE 7 THEN goto,skip_M9
			IF uaid EQ 1 AND band_lit NE 2 THEN goto,skip_M10
			IF uaid EQ 10 AND band_lit NE 3 THEN goto,skip_M11
			IF uaid EQ 4 AND band_lit NE 4 THEN goto,skip_M12
			IF (uaid EQ 6 OR uaid EQ 7) AND band_lit NE 5 THEN goto,skip_M13
			IF uaid EQ 8 OR uaid EQ 9 THEN goto,skip_M13_l


			IF uaid EQ 0 AND band_lit EQ 6 THEN det_drop=7
			IF uaid EQ 3 AND band_lit EQ 7 THEN det_drop=6
			IF uaid EQ 1 AND band_lit EQ 2 THEN det_drop=6
			IF uaid EQ 10 AND band_lit EQ 3 THEN det_drop=7
			IF uaid EQ 4 AND band_lit EQ 4 THEN det_drop=7
			IF (uaid EQ 6 OR uaid EQ 7) AND band_lit EQ 5 THEN det_drop=6

			x3=det_lit-det_drop
			x4=det_lit+det_drop

			IF x3 LT 0 THEN BEGIN
				x3=-1 
				goto,skip_x3
			ENDIF
			FOR s_s=0, n_s-1 DO BEGIN
				FOR i=0, x3 DO BEGIN
					XF_dn_M_t[s_s]=XF_dn_M_t[s_s]+XF_dn_M_r[det_lit,s_s,band_lit-2,i]
					XF_L_M_t[s_s]=XF_L_M_t[s_s]+XF_L_M_r[det_lit,s_s,band_lit-2,i]
					CNR_M_t[s_s]=CNR_M_t[s_s]+CNR_M_r[det_lit,s_s,band_lit-2,i]
					PVP_M_t[s_s]=PVP_M_t[s_s]+PVP_M_r[det_lit,s_s,band_lit-2,i]
				ENDFOR
			ENDFOR
			skip_x3:

			IF x4 GT 15 THEN BEGIN
				x4=16
				goto,skip_x4
			ENDIF
			FOR s_s=0, n_s-1 DO BEGIN
				FOR i=x4, 15 DO BEGIN
					XF_dn_M_t[s_s]=XF_dn_M_t[s_s]+XF_dn_M_r[det_lit,s_s,band_lit-2,i]
					XF_L_M_t[s_s]=XF_L_M_t[s_s]+XF_L_M_r[det_lit,s_s,band_lit-2,i]
					CNR_M_t[s_s]=CNR_M_t[s_s]+CNR_M_r[det_lit,s_s,band_lit-2,i]
					PVP_M_t[s_s]=PVP_M_t[s_s]+PVP_M_r[det_lit,s_s,band_lit-2,i]
				ENDFOR
			ENDFOR
			skip_x4:

			XF_dn_M_t[*]=XF_dn_M_t[*]/(x3+17-x4)
			XF_L_M_t[*]=XF_L_M_t[*]/(x3+17-x4)
			CNR_M_t[*]=CNR_M_t[*]/(x3+17-x4)
			PVP_M_t[*]=PVP_M_t[*]/(x3+17-x4)
			
			FOR i=x3+1, x4-1 DO BEGIN
				IF i EQ det_lit THEN goto,skip_high_2

				XF_dn_M_r[det_lit,*,band_lit-2,i]=XF_dn_M_t[*]
				XF_L_M_r[det_lit,*,band_lit-2,i]=XF_L_M_t[*]
				CNR_M_r[det_lit,*,band_lit-2,i]=CNR_M_t[*]
				PVP_M_r[det_lit,*,band_lit-2,i]=PVP_M_t[*]

				skip_high_2:
			ENDFOR

			skip_M8:
			skip_M9:
			skip_M10:
			skip_M11:
			skip_M12:
			skip_M13:
			skip_M13_l:
			
		ENDIF

;*****************************************************************************
;  Consider the special case of M13 in fixed low or auto low gain.
;*****************************************************************************

		uaid_skip:
		IF uaid EQ 8 OR uaid EQ 9 THEN BEGIN
			
			FOR ib=0, 1 DO BEGIN
				FOR s_s=0, n_s-1 DO BEGIN
					FOR r_s=0, 1 DO BEGIN
						FOR id=0, ndet_I-1 DO BEGIN
							XF_dn_I_g[det_lit,s_s,ib,id,r_s,1,flag-1]=XF_dn_I[det_lit,s_s,ib,id,r_s]
							XF_L_I_g[det_lit,s_s,ib,id,r_s,1,flag-1]=XF_L_I[det_lit,s_s,ib,id,r_s]
							CNR_I_g[det_lit,s_s,ib,id,r_s,1,flag-1]=CNR_I[det_lit,s_s,ib,id,r_s]
							PVP_I_g[det_lit,s_s,ib,id,r_s,1,flag-1]=PVP_I[det_lit,s_s,ib,id,r_s]
							XF_dn_I_g[det_lit,s_s,ib,id,r_s,0,flag-1]=-999
							XF_L_I_g[det_lit,s_s,ib,id,r_s,0,flag-1]=-999
							CNR_I_g[det_lit,s_s,ib,id,r_s,0,flag-1]=-999
							PVP_I_g[det_lit,s_s,ib,id,r_s,0,flag-1]=-999
						ENDFOR
					ENDFOR
				ENDFOR
			ENDFOR

			FOR ib=0, 5 DO BEGIN
				FOR s_s=0, n_s-1 DO BEGIN
					FOR id=0, ndet_I-1 DO BEGIN
						IF ib NE 3 THEN BEGIN
							IF id LT 16 THEN BEGIN
								XF_dn_M_g[det_lit,s_s,ib,id,1,flag-1]=XF_dn_M[det_lit,s_s,ib,id]
								XF_L_M_g[det_lit,s_s,ib,id,1,flag-1]=XF_L_M[det_lit,s_s,ib,id]
								CNR_M_g[det_lit,s_s,ib,id,1,flag-1]=CNR_M[det_lit,s_s,ib,id]
								PVP_M_g[det_lit,s_s,ib,id,1,flag-1]=PVP_M[det_lit,s_s,ib,id]
							ENDIF ELSE BEGIN
								XF_dn_M_g[det_lit,s_s,ib,id,1,flag-1]=-999
								XF_L_M_g[det_lit,s_s,ib,id,1,flag-1]=-999
								CNR_M_g[det_lit,s_s,ib,id,1,flag-1]=-999
								PVP_M_g[det_lit,s_s,ib,id,1,flag-1]=-999
							ENDELSE
							XF_dn_M_g[det_lit,s_s,ib,id,0,flag-1]=-999
							XF_L_M_g[det_lit,s_s,ib,id,0,flag-1]=-999
							CNR_M_g[det_lit,s_s,ib,id,0,flag-1]=-999
							PVP_M_g[det_lit,s_s,ib,id,0,flag-1]=-999
						ENDIF ELSE BEGIN
							det_drop=7
							x5=det_lit-det_drop
							x6=det_lit+det_drop
							IF flag EQ 2 THEN BEGIN
								IF id LT 16 THEN BEGIN
									IF det_low_gain[col,5,id] EQ 1 THEN BEGIN
										XF_dn_M_g[det_lit,s_s,ib,id,0,flag-1]= $
											XF_dn_M[det_lit,s_s,ib,id]
										XF_L_M_g[det_lit,s_s,ib,id,0,flag-1]= $
											XF_L_M[det_lit,s_s,ib,id]
										CNR_M_g[det_lit,s_s,ib,id,0,flag-1]= $
											CNR_M[det_lit,s_s,ib,id]
										PVP_M_g[det_lit,s_s,ib,id,0,flag-1]= $
											PVP_M[det_lit,s_s,ib,id]
										XF_dn_M_g[det_lit,s_s,ib,id,1,flag-1]=-999
										XF_L_M_g[det_lit,s_s,ib,id,1,flag-1]=-999
										CNR_M_g[det_lit,s_s,ib,id,1,flag-1]=-999
										PVP_M_g[det_lit,s_s,ib,id,1,flag-1]=-999
									ENDIF ELSE BEGIN
										XF_dn_M_g[det_lit,s_s,ib,id,1,flag-1]= $
											XF_dn_M[det_lit,s_s,ib,id]
										XF_L_M_g[det_lit,s_s,ib,id,1,flag-1]= $
											XF_L_M[det_lit,s_s,ib,id]
										CNR_M_g[det_lit,s_s,ib,id,1,flag-1]= $
											CNR_M[det_lit,s_s,ib,id]
										PVP_M_g[det_lit,s_s,ib,id,1,flag-1]= $
											PVP_M[det_lit,s_s,ib,id]
										XF_dn_M_g[det_lit,s_s,ib,id,0,flag-1]=-999
										XF_L_M_g[det_lit,s_s,ib,id,0,flag-1]=-999
										CNR_M_g[det_lit,s_s,ib,id,0,flag-1]=-999
										PVP_M_g[det_lit,s_s,ib,id,0,flag-1]=-999
									ENDELSE
								ENDIF ELSE BEGIN
									XF_dn_M_g[det_lit,s_s,ib,id,0,flag-1]=-999
									XF_L_M_g[det_lit,s_s,ib,id,0,flag-1]=-999
									CNR_M_g[det_lit,s_s,ib,id,0,flag-1]=-999
									PVP_M_g[det_lit,s_s,ib,id,0,flag-1]=-999
									XF_dn_M_g[det_lit,s_s,ib,id,1,flag-1]=-999
									XF_L_M_g[det_lit,s_s,ib,id,1,flag-1]=-999
									CNR_M_g[det_lit,s_s,ib,id,1,flag-1]=-999
									PVP_M_g[det_lit,s_s,ib,id,1,flag-1]=-999
								ENDELSE
							ENDIF
							IF flag EQ 1 THEN BEGIN
								IF id LT 16 THEN BEGIN
									XF_dn_M_g[det_lit,s_s,ib,id,0,flag-1]= $
										XF_dn_M[det_lit,s_s,ib,id]
									XF_L_M_g[det_lit,s_s,ib,id,0,flag-1]= $
										XF_L_M[det_lit,s_s,ib,id]
									CNR_M_g[det_lit,s_s,ib,id,0,flag-1]= $
										CNR_M[det_lit,s_s,ib,id]
									PVP_M_g[det_lit,s_s,ib,id,0,flag-1]= $
										PVP_M[det_lit,s_s,ib,id]
									XF_dn_M_g[det_lit,s_s,ib,id,1,flag-1]=-999
									XF_L_M_g[det_lit,s_s,ib,id,1,flag-1]=-999
									CNR_M_g[det_lit,s_s,ib,id,1,flag-1]=-999
									PVP_M_g[det_lit,s_s,ib,id,1,flag-1]=-999
								ENDIF ELSE BEGIN
									XF_dn_M_g[det_lit,s_s,ib,id,0,flag-1]=-999
									XF_L_M_g[det_lit,s_s,ib,id,0,flag-1]=-999
									CNR_M_g[det_lit,s_s,ib,id,0,flag-1]=-999
									PVP_M_g[det_lit,s_s,ib,id,0,flag-1]=-999
									XF_dn_M_g[det_lit,s_s,ib,id,1,flag-1]=-999
									XF_L_M_g[det_lit,s_s,ib,id,1,flag-1]=-999
									CNR_M_g[det_lit,s_s,ib,id,1,flag-1]=-999
									PVP_M_g[det_lit,s_s,ib,id,1,flag-1]=-999
								ENDELSE
							ENDIF
						ENDELSE
					ENDFOR
				ENDFOR
			ENDFOR

;*****************************************************************************
;  Include in-track correction for M13 fixed low or auto low gain.
;*****************************************************************************

			FOR s_s=0, n_s-1 DO BEGIN
				XF_dn_M_t_g[*,s_s]=0
				XF_L_M_t_g[*,s_s]=0
				CNR_M_t_g[*,s_s]=0
				PVP_M_t_g[*,s_s]=0
			ENDFOR

			det_drop=8

			x5=det_lit-det_drop
			x6=det_lit+det_drop

			IF flag EQ 1 THEN BEGIN
				IF x5 LT 0 THEN BEGIN
					x5=-1 
					goto,skip_x5
				ENDIF
				FOR s_s=0, n_s-1 DO BEGIN
					FOR i=0, x5 DO BEGIN
						XF_dn_M_t_g[0,s_s]=XF_dn_M_t_g[0,s_s]+XF_dn_M_g[det_lit,s_s,3,i,0,flag-1]
						XF_L_M_t_g[0,s_s]=XF_L_M_t_g[0,s_s]+XF_L_M_g[det_lit,s_s,3,i,0,flag-1]
						CNR_M_t_g[0,s_s]=CNR_M_t_g[0,s_s]+CNR_M_g[det_lit,s_s,3,i,0,flag-1]
						PVP_M_t_g[0,s_s]=PVP_M_t_g[0,s_s]+PVP_M_g[det_lit,s_s,3,i,0,flag-1]
					ENDFOR
				ENDFOR
				skip_x5:

				IF x6 GT 15 THEN BEGIN
					x6=16
					goto,skip_x6
				ENDIF
				FOR s_s=0, n_s-1 DO BEGIN
					FOR i=x6, 15 DO BEGIN
						XF_dn_M_t_g[0,s_s]=XF_dn_M_t_g[0,s_s]+XF_dn_M_g[det_lit,s_s,3,i,0,flag-1]
						XF_L_M_t_g[0,s_s]=XF_L_M_t_g[0,s_s]+XF_L_M_g[det_lit,s_s,3,i,0,flag-1]
						CNR_M_t_g[0,s_s]=CNR_M_t_g[0,s_s]+CNR_M_g[det_lit,s_s,3,i,0,flag-1]
						PVP_M_t_g[0,s_s]=PVP_M_t_g[0,s_s]+PVP_M_g[det_lit,s_s,3,i,0,flag-1]
					ENDFOR
				ENDFOR
				skip_x6:

				XF_dn_M_t_g[0,*]=XF_dn_M_t_g[0,*]/(x5+17-x6)
				XF_L_M_t_g[0,*]=XF_L_M_t_g[0,*]/(x5+17-x6)
				CNR_M_t_g[0,*]=CNR_M_t_g[0,*]/(x5+17-x6)
				PVP_M_t_g[0,*]=PVP_M_t_g[0,*]/(x5+17-x6)

				FOR i=x5+1, x6-1 DO BEGIN
					FOR s_s=0, n_s-1 DO BEGIN
						IF i EQ det_lit THEN goto,skip_high_3

							XF_dn_M_g[det_lit,s_s,3,i,0,flag-1]=XF_dn_M_t_g[0,s_s]
							XF_L_M_g[det_lit,s_s,3,i,0,flag-1]=XF_L_M_t_g[0,s_s]
							CNR_M_g[det_lit,s_s,3,i,0,flag-1]=CNR_M_t_g[0,s_s]
							PVP_M_g[det_lit,s_s,3,i,0,flag-1]=PVP_M_t_g[0,s_s]

						skip_high_3:
					ENDFOR
				ENDFOR
			ENDIF

			FOR s_s=0, n_s-1 DO BEGIN
				XF_dn_M_t_g[0,s_s]=0
				XF_L_M_t_g[0,s_s]=0
				CNR_M_t_g[0,s_s]=0
				PVP_M_t_g[0,s_s]=0
			ENDFOR

			det_drop=8

			x7=det_lit-det_drop
			x8=det_lit+det_drop

			IF flag EQ 2 THEN BEGIN
				IF x7 LT 0 THEN BEGIN
					x7=-1 
					goto,skip_x7
				ENDIF
				FOR s_s=0, n_s-1 DO BEGIN
					FOR i=0, x7 DO BEGIN
						XF_dn_M_t_g[0,s_s]=XF_dn_M_t_g[0,s_s]+XF_dn_M_g[det_lit,s_s,3,i,1,flag-1]
						XF_L_M_t_g[0,s_s]=XF_L_M_t_g[0,s_s]+XF_L_M_g[det_lit,s_s,3,i,1,flag-1]
						CNR_M_t_g[0,s_s]=CNR_M_t_g[0,s_s]+CNR_M_g[det_lit,s_s,3,i,1,flag-1]
						PVP_M_t_g[0,s_s]=PVP_M_t_g[0,s_s]+PVP_M_g[det_lit,s_s,3,i,1,flag-1]
					ENDFOR
				ENDFOR
				skip_x7:

				IF x8 GT 15 THEN BEGIN
					x8=16
					goto,skip_x8
				ENDIF
				FOR s_s=0, n_s-1 DO BEGIN
					FOR i=x8, 15 DO BEGIN
						XF_dn_M_t_g[0,s_s]=XF_dn_M_t_g[0,s_s]+XF_dn_M_g[det_lit,s_s,3,i,1,flag-1]
						XF_L_M_t_g[0,s_s]=XF_L_M_t_g[0,s_s]+XF_L_M_g[det_lit,s_s,3,i,1,flag-1]
						CNR_M_t_g[0,s_s]=CNR_M_t_g[0,s_s]+CNR_M_g[det_lit,s_s,3,i,1,flag-1]
						PVP_M_t_g[0,s_s]=PVP_M_t_g[0,s_s]+PVP_M_g[det_lit,s_s,3,i,1,flag-1]
					ENDFOR
				ENDFOR
				skip_x8:

				XF_dn_M_t_g[0,*]=XF_dn_M_t_g[0,*]/(x7+17-x8)
				XF_L_M_t_g[0,*]=XF_L_M_t_g[0,*]/(x7+17-x8)
				CNR_M_t_g[0,*]=CNR_M_t_g[0,*]/(x7+17-x8)
				PVP_M_t_g[0,*]=PVP_M_t_g[0,*]/(x7+17-x8)

				FOR i=x7+1, x8-1 DO BEGIN
					FOR s_s=0, n_s-1 DO BEGIN
						IF i EQ det_lit THEN goto,skip_high_4

						IF det_low_gain[col,5,i] EQ 1 THEN BEGIN
							XF_dn_M_g[det_lit,s_s,3,i,0,flag-1]=XF_dn_M_t_g[0,s_s]
							XF_L_M_g[det_lit,s_s,3,i,0,flag-1]=XF_L_M_t_g[0,s_s]
							CNR_M_g[det_lit,s_s,3,i,0,flag-1]=CNR_M_t_g[0,s_s]
							PVP_M_g[det_lit,s_s,3,i,0,flag-1]=PVP_M_t_g[0,s_s]
						ENDIF ELSE BEGIN
							XF_dn_M_g[det_lit,s_s,3,i,1,flag-1]=XF_dn_M_t_g[0,s_s]
							XF_L_M_g[det_lit,s_s,3,i,1,flag-1]=XF_L_M_t_g[0,s_s]
							CNR_M_g[det_lit,s_s,3,i,1,flag-1]=CNR_M_t_g[0,s_s]
							PVP_M_g[det_lit,s_s,3,i,1,flag-1]=PVP_M_t_g[0,s_s]
						ENDELSE

						skip_high_4:
					ENDFOR
				ENDFOR
			ENDIF

		ENDIF

		skip_col:
	ENDFOR

;*****************************************************************************
;  Display CNR that are above 1 (or below -1) and print to files.
;*****************************************************************************

	IF uaid EQ 2 OR uaid EQ 5 THEN n_s=2
	IF uaid NE 2 AND uaid NE 5 THEN n_s=1
	IF uaid EQ 2 OR uaid EQ 5 THEN n_det=32
	IF uaid NE 2 AND uaid NE 5 THEN n_det=16

	FOR s_s=0, n_s-1 DO BEGIN
		FOR iflag=0, 1 DO BEGIN
			FOR s_det=0, n_det-1 DO BEGIN
				FOR i=0, ndet_M-1 DO BEGIN
				;	IF abs(CNR_M_g[s_det,s_s,3,i,1,0]) GT 1 THEN print,'M',s_det+1,ib,i+1
					IF abs(CNR_M_g[s_det,s_s,3,i,1,1]) GT 1 THEN print,'M',s_det+1,ib,i+1
				ENDFOR
			ENDFOR
		ENDFOR
	ENDFOR

	IF uaid NE 8 AND uaid NE 9 THEN BEGIN
		FOR s_s=0, n_s-1 DO BEGIN
			FOR s_det=0, n_det-1 DO BEGIN
				FOR id=0, ndet_I-1 DO BEGIN
					printf,lun,s_s+1,s_det+1,id+1,XF_dn_M_r[s_det,s_s,3,id],XF_dn_M_r[s_det,s_s,2,id], $
						XF_dn_I_r[s_det,s_s,1,id,0],XF_dn_I_r[s_det,s_s,1,id,1], $
						XF_dn_I_r[s_det,s_s,0,id,0],XF_dn_I_r[s_det,s_s,0,id,1], $
						XF_dn_M_r[s_det,s_s,0,id],XF_dn_M_r[s_det,s_s,1,id], $
						XF_dn_M_r[s_det,s_s,4,id],XF_dn_M_r[s_det,s_s,5,id],format=fmt
					printf,lon,s_s+1,s_det+1,id+1,XF_L_M_r[s_det,s_s,3,id],XF_L_M_r[s_det,s_s,2,id], $
						XF_L_I_r[s_det,s_s,1,id,0],XF_L_I_r[s_det,s_s,1,id,1], $
						XF_L_I_r[s_det,s_s,0,id,0],XF_L_I_r[s_det,s_s,0,id,1], $
						XF_L_M_r[s_det,s_s,0,id],XF_L_M_r[s_det,s_s,1,id], $
						XF_L_M_r[s_det,s_s,4,id],XF_L_M_r[s_det,s_s,5,id],format=fmt
					printf,len,s_s+1,s_det+1,id+1,CNR_M_r[s_det,s_s,3,id],CNR_M_r[s_det,s_s,2,id], $
						CNR_I_r[s_det,s_s,1,id,0],CNR_I_r[s_det,s_s,1,id,1], $
						CNR_I_r[s_det,s_s,0,id,0],CNR_I_r[s_det,s_s,0,id,1], $
						CNR_M_r[s_det,s_s,0,id],CNR_M_r[s_det,s_s,1,id], $
						CNR_M_r[s_det,s_s,4,id],CNR_M_r[s_det,s_s,5,id],format=fmt
					printf,lin,s_s+1,s_det+1,id+1,PVP_M_r[s_det,s_s,3,id],PVP_M_r[s_det,s_s,2,id], $
						PVP_I_r[s_det,s_s,1,id,0],PVP_I_r[s_det,s_s,1,id,1], $
						PVP_I_r[s_det,s_s,0,id,0],PVP_I_r[s_det,s_s,0,id,1], $
						PVP_M_r[s_det,s_s,0,id],PVP_M_r[s_det,s_s,1,id], $
						PVP_M_r[s_det,s_s,4,id],PVP_M_r[s_det,s_s,5,id],format=fmt
				ENDFOR
			ENDFOR
		ENDFOR
	ENDIF
	IF uaid EQ 8 OR uaid EQ 9 THEN BEGIN
		FOR iflag=0, 1 DO BEGIN
			FOR s_det=0, n_det-1 DO BEGIN
				FOR id=0, ndet_I-1 DO BEGIN
					printf,lun,1,s_det+1,id+1,1-iflag,XF_dn_M_g[s_det,0,3,id,1-iflag,1], $
						XF_dn_M_g[s_det,0,2,id,1-iflag,1],XF_dn_I_g[s_det,0,1,id,0,1-iflag,1], $
						XF_dn_I_g[s_det,0,1,id,1,1-iflag,1],XF_dn_I_g[s_det,0,0,id,0,1-iflag,1], $
						XF_dn_I_g[s_det,0,0,id,1,1-iflag,1],XF_dn_M_g[s_det,0,0,id,1-iflag,1], $
						XF_dn_M_g[s_det,0,1,id,1-iflag,1],XF_dn_M_g[s_det,0,4,id,1-iflag,1], $
						XF_dn_M_g[s_det,0,5,id,1-iflag,1],format=fmt2
					printf,lon,1,s_det+1,id+1,1-iflag,XF_L_M_g[s_det,0,3,id,1-iflag,1], $
						XF_L_M_g[s_det,0,2,id,1-iflag,1],XF_L_I_g[s_det,0,1,id,0,1-iflag,1], $
						XF_L_I_g[s_det,0,1,id,1,1-iflag,1],XF_L_I_g[s_det,0,0,id,0,1-iflag,1], $
						XF_L_I_g[s_det,0,0,id,1,1-iflag,1],XF_L_M_g[s_det,0,0,id,1-iflag,1], $
						XF_L_M_g[s_det,0,1,id,1-iflag,1],XF_L_M_g[s_det,0,4,id,1-iflag,1], $
						XF_L_M_g[s_det,0,5,id,1-iflag,1],format=fmt2
					printf,len,1,s_det+1,id+1,1-iflag,CNR_M_g[s_det,0,3,id,1-iflag,1], $
						CNR_M_g[s_det,0,2,id,1-iflag,1],CNR_I_g[s_det,0,1,id,0,1-iflag,1], $
						CNR_I_g[s_det,0,1,id,1,1-iflag,1],CNR_I_g[s_det,0,0,id,0,1-iflag,1], $
						CNR_I_g[s_det,0,0,id,1,1-iflag,1],CNR_M_g[s_det,0,0,id,1-iflag,1], $
						CNR_M_g[s_det,0,1,id,1-iflag,1],CNR_M_g[s_det,0,4,id,1-iflag,1], $
						CNR_M_g[s_det,0,5,id,1-iflag,1],format=fmt2
					printf,lin,1,s_det+1,id+1,1-iflag,PVP_M_g[s_det,0,3,id,1-iflag,1], $
						PVP_M_g[s_det,0,2,id,1-iflag,1],PVP_I_g[s_det,0,1,id,0,1-iflag,1], $
						PVP_I_g[s_det,0,1,id,1,1-iflag,1],PVP_I_g[s_det,0,0,id,0,1-iflag,1], $
						PVP_I_g[s_det,0,0,id,1,1-iflag,1],PVP_M_g[s_det,0,0,id,1-iflag,1], $
						PVP_M_g[s_det,0,1,id,1-iflag,1],PVP_M_g[s_det,0,4,id,1-iflag,1], $
						PVP_M_g[s_det,0,5,id,1-iflag,1],format=fmt2
					printf,lun_2,1,s_det+1,id+1,1-iflag,XF_dn_M_g[s_det,0,3,id,1-iflag,0], $
						XF_dn_M_g[s_det,0,2,id,1-iflag,0],XF_dn_I_g[s_det,0,1,id,0,1-iflag,0], $
						XF_dn_I_g[s_det,0,1,id,1,1-iflag,0],XF_dn_I_g[s_det,0,0,id,0,1-iflag,0], $
						XF_dn_I_g[s_det,0,0,id,1,1-iflag,0],XF_dn_M_g[s_det,0,0,id,1-iflag,0], $
						XF_dn_M_g[s_det,0,1,id,1-iflag,0],XF_dn_M_g[s_det,0,4,id,1-iflag,0], $
						XF_dn_M_g[s_det,0,5,id,1-iflag,0],format=fmt2
					printf,lon_2,1,s_det+1,id+1,1-iflag,XF_L_M_g[s_det,0,3,id,1-iflag,0], $
						XF_L_M_g[s_det,0,2,id,1-iflag,0],XF_L_I_g[s_det,0,1,id,0,1-iflag,0], $
						XF_L_I_g[s_det,0,1,id,1,1-iflag,0],XF_L_I_g[s_det,0,0,id,0,1-iflag,0], $
						XF_L_I_g[s_det,0,0,id,1,1-iflag,0],XF_L_M_g[s_det,0,0,id,1-iflag,0], $
						XF_L_M_g[s_det,0,1,id,1-iflag,0],XF_L_M_g[s_det,0,4,id,1-iflag,0], $
						XF_L_M_g[s_det,0,5,id,1-iflag,0],format=fmt2
					printf,len_2,1,s_det+1,id+1,1-iflag,CNR_M_g[s_det,0,3,id,1-iflag,0], $
						CNR_M_g[s_det,0,2,id,1-iflag,0],CNR_I_g[s_det,0,1,id,0,1-iflag,0], $
						CNR_I_g[s_det,0,1,id,1,1-iflag,0],CNR_I_g[s_det,0,0,id,0,1-iflag,0], $
						CNR_I_g[s_det,0,0,id,1,1-iflag,0],CNR_M_g[s_det,0,0,id,1-iflag,0], $
						CNR_M_g[s_det,0,1,id,1-iflag,0],CNR_M_g[s_det,0,4,id,1-iflag,0], $
						CNR_M_g[s_det,0,5,id,1-iflag,0],format=fmt2
					printf,lin_2,1,s_det+1,id+1,1-iflag,PVP_M_g[s_det,0,3,id,1-iflag,0], $
						PVP_M_g[s_det,0,2,id,1-iflag,0],PVP_I_g[s_det,0,1,id,0,1-iflag,0], $
						PVP_I_g[s_det,0,1,id,1,1-iflag,0],PVP_I_g[s_det,0,0,id,0,1-iflag,0], $
						PVP_I_g[s_det,0,0,id,1,1-iflag,0],PVP_M_g[s_det,0,0,id,1-iflag,0], $
						PVP_M_g[s_det,0,1,id,1-iflag,0],PVP_M_g[s_det,0,4,id,1-iflag,0], $
						PVP_M_g[s_det,0,5,id,1-iflag,0],format=fmt2
				ENDFOR
			ENDFOR
		ENDFOR
	ENDIF

	save,/compress,XF_dn_I_r,XF_dn_M_r,XF_L_I_r,XF_L_M_r,CNR_I_r,CNR_M_r,PVP_I_r,PVP_M_r, $
		XF_dn_I_g,XF_dn_M_g,XF_L_I_g,XF_L_M_g,CNR_I_g,CNR_M_g,PVP_I_g,PVP_M_g, $
		filename='/home/jmcintire/VIIRS_Data/FP_13_Data/SMWIR/U'+uaidname[uaid]+'.coeff.reform.sav'

	Free_lun,lun
	close,/all

	skip_loop:
ENDFOR

close,/all

END
